/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.43 from the
 * contents of Float128.xs. Do not edit this file, edit Float128.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "Float128.xs"

#ifdef  __MINGW32__
#ifndef __USE_MINGW_ANSI_STDIO
#define __USE_MINGW_ANSI_STDIO 1
#endif
#endif

#define PERL_NO_GET_CONTEXT 1

#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"


#include "math_float128_include.h"

int nnum = 0;

int nok_pok = 0; /* flag that is incremented whenever a scalar that is both
                 NOK and POK is passed to new or an overloaded operator */

int NOK_POK_val(pTHX) {
  /* return the numeric value of $Math::MPFR::NOK_POK */
  return SvIV(get_sv("Math::Float128::NOK_POK", 0));
}

int _win32_infnanstring(char * s) { /* MS Windows only - detect 1.#INF and 1.#IND
                                     * Need to do this to correctly handle a scalar
                                     * that is both NOK and POK on older win32 perls */

  /*************************************
  * if input string    =~ /^\-1\.#INF$/ return -1
  * elsif input string =~ /^\+?1\.#INF$/i return 1
  * elsif input string =~ /^(\-|\+)?1\.#IND$/i return 2
  * else return 0
  **************************************/

#ifdef _WIN32_BIZARRE_INFNAN

  int sign = 1;
  int factor = 1;

  if(s[0] == '-') {
    sign = -1;
    s++;
  }
  else {
    if(s[0] == '+') s++;
  }

  if(!strcmp(s, "1.#INF")) return sign;
  if(!strcmp(s, "1.#IND")) return 2;

  return 0;
#else
  croak("Math::Float128::_win32_infnanstring not implemented for this build of perl");
#endif
}

void flt128_set_prec(pTHX_ int x) {
    if(x < 1)croak("1st arg (precision) to flt128_set_prec must be at least 1");
    _DIGITS = x;
}

int flt128_get_prec(void) {
     return _DIGITS;
}

int _is_nan(float128 x) {
    if(x != x) return 1;
    return 0;
}

int  _is_inf(float128 x) {
     if(x != x) return 0; /* NaN  */
     if(x == 0.0Q) return 0; /* Zero */
     if(x/x != x/x) {
       if(x < 0.0Q) return -1;
       else return 1;
     }
     return 0; /* Finite Real */
}

/* Replaced */
/*
//int  _is_zero(float128 x) {
//     char * buffer;
//
//     if(x != 0.0Q) return 0;
//
//     Newx(buffer, 2, char);
//
//     quadmath_snprintf(buffer, sizeof buffer, "%.0Qf", x);
//
//     if(!strcmp(buffer, "-0")) {
//       Safefree(buffer);
//       return -1;
//     }
//
//     Safefree(buffer);
//     return 1;
//}
*/

int _is_zero(float128 x) {

  int n = sizeof(float128);
  void * p = &x;

  if(x != 0.0Q) return 0;

#ifdef WE_HAVE_BENDIAN /* Big Endian architecture */
  if(((unsigned char*)p)[0] >= 128) return -1;
#else
  if(((unsigned char*)p)[n - 1] >= 128) return -1;
#endif
  return 1;
}

float128 _get_inf(int sign) {
    float128 ret;
    ret = FLT128_MAX * 2.0Q;
    if(sign < 0) ret *= -1.0Q;
    return ret;
}

float128 _get_nan(void) {
     float128 inf = _get_inf(1);
     return inf / inf;
}

SV * InfF128(pTHX_ int sign) {
     float128 * f;
     SV * obj_ref, * obj;

     Newx(f, 1, float128);
     if(f == NULL) croak("Failed to allocate memory in InfF128 function");

     obj_ref = newSV(0);
     obj = newSVrv(obj_ref, "Math::Float128");

     *f = _get_inf(sign);

     sv_setiv(obj, INT2PTR(IV,f));
     SvREADONLY_on(obj);
     return obj_ref;
}

SV * NaNF128(pTHX) {
     float128 * f;
     SV * obj_ref, * obj;

     Newx(f, 1, float128);
     if(f == NULL) croak("Failed to allocate memory in NaNF128 function");

     obj_ref = newSV(0);
     obj = newSVrv(obj_ref, "Math::Float128");

     *f = _get_nan();

     sv_setiv(obj, INT2PTR(IV,f));
     SvREADONLY_on(obj);
     return obj_ref;
}

SV * ZeroF128(pTHX_ int sign) {
     float128 * f;
     SV * obj_ref, * obj;

     Newx(f, 1, float128);
     if(f == NULL) croak("Failed to allocate memory in ZeroF128 function");

     obj_ref = newSV(0);
     obj = newSVrv(obj_ref, "Math::Float128");

     *f = 0.0Q;
     if(sign < 0) *f *= -1;

     sv_setiv(obj, INT2PTR(IV,f));
     SvREADONLY_on(obj);
     return obj_ref;
}

SV * UnityF128(pTHX_ int sign) {
     float128 * f;
     SV * obj_ref, * obj;

     Newx(f, 1, float128);
     if(f == NULL) croak("Failed to allocate memory in UnityF128 function");

     obj_ref = newSV(0);
     obj = newSVrv(obj_ref, "Math::Float128");

     *f = 1.0Q;
     if(sign < 0) *f *= -1;

     sv_setiv(obj, INT2PTR(IV,f));
     SvREADONLY_on(obj);
     return obj_ref;
}

SV * is_NaNF128(pTHX_ SV * b) {
     if(sv_isobject(b)) {
       const char *h = HvNAME(SvSTASH(SvRV(b)));
       if(strEQ(h, "Math::Float128"))
         return newSViv(_is_nan(*(INT2PTR(float128 *, SvIVX(SvRV(b))))));
     }
     croak("Invalid argument supplied to Math::Float128::isNaNF128 function");
}

SV * is_InfF128(pTHX_ SV * b) {
     if(sv_isobject(b)) {
       const char *h = HvNAME(SvSTASH(SvRV(b)));
       if(strEQ(h, "Math::Float128"))
         return newSViv(_is_inf(*(INT2PTR(float128 *, SvIVX(SvRV(b))))));
     }
     croak("Invalid argument supplied to Math::Float128::is_InfF128 function");
}

SV * is_ZeroF128(pTHX_ SV * b) {
     if(sv_isobject(b)) {
       const char *h = HvNAME(SvSTASH(SvRV(b)));
       if(strEQ(h, "Math::Float128"))
         return newSViv(_is_zero(*(INT2PTR(float128 *, SvIVX(SvRV(b))))));
     }
     croak("Invalid argument supplied to Math::Float128::is_ZeroF128 function");
}


void _nnum_inc (char * p) {
  int i = 0;
  for(;;i++) {
    if(p[i] == 0) break;
    if(p[i] != ' ' && p[i] != '\t' && p[i] != '\n' && p[i] != '\r' && p[i] != '\f') {
       nnum++;
       break;
    }
  }
}

SV * STRtoF128(pTHX_ SV * str) {
     float128 * f;
     SV * obj_ref, * obj;
     char * p;
     int inf_or_nan = 0;

     Newx(f, 1, float128);
     if(f == NULL) croak("Failed to allocate memory in STRtoF128 function");

     obj_ref = newSV(0);
     obj = newSVrv(obj_ref, "Math::Float128");

#ifdef _WIN32_BIZARRE_INFNAN
     inf_or_nan = _win32_infnanstring(SvPV_nolen(str));
     if(inf_or_nan) {
       if(inf_or_nan == 2) *f = _get_nan();
       else *f = _get_inf(inf_or_nan);
     }
     else *f = strtoflt128(SvPV_nolen(str), &p);
#else
     *f = strtoflt128(SvPV_nolen(str), &p);
#endif

     if(!inf_or_nan) _nnum_inc(p);

     sv_setiv(obj, INT2PTR(IV,f));
     SvREADONLY_on(obj);
     return obj_ref;
}

void fromSTR(pTHX_ float128 * f, SV * str) {
     char * p;
     int inf_or_nan = 0;

#ifdef _WIN32_BIZARRE_INFNAN
     inf_or_nan = _win32_infnanstring(SvPV_nolen(str));
     if(inf_or_nan) {
       if(inf_or_nan == 2) *f = _get_nan();
       else *f = _get_inf(inf_or_nan);
     }
     else *f = strtoflt128(SvPV_nolen(str), &p);
#else
     *f = strtoflt128(SvPV_nolen(str), &p);
#endif

     if(!inf_or_nan) _nnum_inc(p);

}

SV * NVtoF128(pTHX_ SV * nv) {
     float128 * f;
     SV * obj_ref, * obj;

     Newx(f, 1, float128);
     if(f == NULL) croak("Failed to allocate memory in NVtoF128 function");

     obj_ref = newSV(0);
     obj = newSVrv(obj_ref, "Math::Float128");

     *f = (float128)SvNV(nv);

     sv_setiv(obj, INT2PTR(IV,f));
     SvREADONLY_on(obj);
     return obj_ref;
}

void fromNV(pTHX_ float128 * f, SV * nv) {
     *f = (float128)SvNV(nv);
}

SV * IVtoF128(pTHX_ SV * iv) {
     float128 * f;
     SV * obj_ref, * obj;

     Newx(f, 1, float128);
     if(f == NULL) croak("Failed to allocate memory in IVtoF128 function");

     obj_ref = newSV(0);
     obj = newSVrv(obj_ref, "Math::Float128");

     *f = (float128)SvIV(iv);

     sv_setiv(obj, INT2PTR(IV,f));
     SvREADONLY_on(obj);
     return obj_ref;
}

void fromIV(pTHX_ float128 * f, SV * iv) {
     *f = (float128)SvIV(iv);
}

SV * UVtoF128(pTHX_ SV * uv) {
     float128 * f;
     SV * obj_ref, * obj;

     Newx(f, 1, float128);
     if(f == NULL) croak("Failed to allocate memory in UVtoF128 function");

     obj_ref = newSV(0);
     obj = newSVrv(obj_ref, "Math::Float128");

     *f = (float128)SvUV(uv);

     sv_setiv(obj, INT2PTR(IV,f));
     SvREADONLY_on(obj);
     return obj_ref;
}

void fromUV(pTHX_ float128 * f,SV * uv) {
     *f = (float128)SvUV(uv);
}

void F128toSTR(pTHX_ SV * f) {
     dXSARGS;
     float128 t;
     char * buffer;

     if(sv_isobject(f)) {
       const char *h = HvNAME(SvSTASH(SvRV(f)));
       if(strEQ(h, "Math::Float128")) {
          EXTEND(SP, 1);
          t = *(INT2PTR(float128 *, SvIVX(SvRV(f))));

          Newx(buffer, 15 + _DIGITS, char);
          if(buffer == NULL) croak("Failed to allocate memory in F128toSTR");
          quadmath_snprintf(buffer, 15 + _DIGITS, "%.*Qe", _DIGITS - 1, t);
          ST(0) = sv_2mortal(newSVpv(buffer, 0));
          Safefree(buffer);
          XSRETURN(1);
       }
       else croak("Invalid object supplied to Math::Float128::F128toSTR function");
     }
     else croak("Invalid argument supplied to Math::Float128::F128toSTR function");
}

void F128toSTRP(pTHX_ SV * f, int decimal_prec) {
     dXSARGS;
     float128 t;
     char * buffer;

     if(decimal_prec < 1)croak("2nd arg (precision) to F128toSTRP  must be at least 1");

     if(sv_isobject(f)) {
       const char *h = HvNAME(SvSTASH(SvRV(f)));
       if(strEQ(h, "Math::Float128")) {
          EXTEND(SP, 1);
          t = *(INT2PTR(float128 *, SvIVX(SvRV(f))));

          Newx(buffer, 12 + decimal_prec, char);
          if(buffer == NULL) croak("Failed to allocate memory in F128toSTRP");
          quadmath_snprintf(buffer, 12 + decimal_prec, "%.*Qe", decimal_prec - 1, t);
          ST(0) = sv_2mortal(newSVpv(buffer, 0));
          Safefree(buffer);
          XSRETURN(1);
       }
       else croak("Invalid object supplied to Math::Float128::F128toSTRP function");
     }
     else croak("Invalid argument supplied to Math::Float128::F128toSTRP function");
}

void DESTROY(pTHX_ SV *  f) {
     Safefree(INT2PTR(float128 *, SvIVX(SvRV(f))));
}

SV * _LDBL_DIG(pTHX) {
#ifdef LDBL_DIG
     return newSViv(LDBL_DIG);
#else
     croak("LDBL_DIG not implemented");
#endif
}

SV * _DBL_DIG(pTHX) {
#ifdef DBL_DIG
     return newSViv(DBL_DIG);
#else
     croak("DBL_DIG not implemented");
#endif
}

SV * _FLT128_DIG(pTHX) {
#ifdef FLT128_DIG
     return newSViv(FLT128_DIG);
#else
     croak("FLT128_DIG not implemented");
#endif
}

SV * _overload_add(pTHX_ SV * a, SV * b, SV * third) {

     float128 * ld;
     SV * obj_ref, * obj;

     Newx(ld, 1, float128);
     if(ld == NULL) croak("Failed to allocate memory in _overload_add function");

     obj_ref = newSV(0);
     obj = newSVrv(obj_ref, "Math::Float128");

     sv_setiv(obj, INT2PTR(IV,ld));
     SvREADONLY_on(obj);

    if(SvUOK(b)) {
       *ld = *(INT2PTR(float128 *, SvIVX(SvRV(a)))) + (float128)SvUVX(b);
        return obj_ref;
    }

    if(SvIOK(b)) {
       *ld = *(INT2PTR(float128 *, SvIVX(SvRV(a)))) + (float128)SvIVX(b);
        return obj_ref;
    }

    if(SvPOK(b)) {
       char * p;
#ifdef _WIN32_BIZARRE_INFNAN
       int inf_or_nan = _win32_infnanstring(SvPV_nolen(b));
#endif

       NOK_POK_DUALVAR_CHECK , "overload_add");}

#ifdef _WIN32_BIZARRE_INFNAN
       if(inf_or_nan) {
         if(inf_or_nan == 2) *ld = _get_nan();
         else *ld = *(INT2PTR(float128 *, SvIVX(SvRV(a)))) + _get_inf(inf_or_nan);
       }
       else {
         *ld = *(INT2PTR(float128 *, SvIVX(SvRV(a)))) + strtoflt128(SvPV_nolen(b), &p);
         _nnum_inc(p);
       }
#else
       *ld = *(INT2PTR(float128 *, SvIVX(SvRV(a)))) + strtoflt128(SvPV_nolen(b), &p);
       _nnum_inc(p);
#endif
       return obj_ref;
    }

    if(SvNOK(b)) {
#if defined(AVOID_INF_CAST)
       if(SvNVX(b) != 0.0L && SvNVX(b) == SvNVX(b) && SvNVX(b) / SvNVX(b) != SvNVX(b) / SvNVX(b)) {
         *ld = *(INT2PTR(float128 *, SvIVX(SvRV(a)))) + _get_inf(SvNVX(b) > 0 ? 1 : -1);
         return obj_ref;
       }
#endif
       *ld = *(INT2PTR(float128 *, SvIVX(SvRV(a)))) + (float128)SvNVX(b);
        return obj_ref;
    }

    if(sv_isobject(b)) {
       const char *h = HvNAME(SvSTASH(SvRV(b)));
       if(strEQ(h, "Math::Float128")) {
        *ld = *(INT2PTR(float128 *, SvIVX(SvRV(a)))) + *(INT2PTR(float128 *, SvIVX(SvRV(b))));
        return obj_ref;
      }
      croak("Invalid object supplied to Math::Float128::_overload_add function");
    }

    croak("Invalid argument supplied to Math::Float128::_overload_add function");
}

SV * _overload_mul(pTHX_ SV * a, SV * b, SV * third) {

     float128 * ld;
     SV * obj_ref, * obj;

     Newx(ld, 1, float128);
     if(ld == NULL) croak("Failed to allocate memory in _overload_mul function");

     obj_ref = newSV(0);
     obj = newSVrv(obj_ref, "Math::Float128");

     sv_setiv(obj, INT2PTR(IV,ld));
     SvREADONLY_on(obj);

    if(SvUOK(b)) {
       *ld = *(INT2PTR(float128 *, SvIVX(SvRV(a)))) * (float128)SvUVX(b);
        return obj_ref;
    }

    if(SvIOK(b)) {
       *ld = *(INT2PTR(float128 *, SvIVX(SvRV(a)))) * (float128)SvIVX(b);
        return obj_ref;
    }

    if(SvPOK(b)) {
       char * p;
#ifdef _WIN32_BIZARRE_INFNAN
       int inf_or_nan = _win32_infnanstring(SvPV_nolen(b));
#endif

       NOK_POK_DUALVAR_CHECK , "overload_mul");}

#ifdef _WIN32_BIZARRE_INFNAN
       if(inf_or_nan) {
         if(inf_or_nan == 2) *ld = _get_nan();
         else *ld = *(INT2PTR(float128 *, SvIVX(SvRV(a)))) * _get_inf(inf_or_nan);
       }
       else {
         *ld = *(INT2PTR(float128 *, SvIVX(SvRV(a)))) * strtoflt128(SvPV_nolen(b), &p);
         _nnum_inc(p);
       }
#else
       *ld = *(INT2PTR(float128 *, SvIVX(SvRV(a)))) * strtoflt128(SvPV_nolen(b), &p);
       _nnum_inc(p);
#endif
       return obj_ref;
    }

    if(SvNOK(b)) {
#if defined(AVOID_INF_CAST)
       if(SvNVX(b) != 0.0L && SvNVX(b) == SvNVX(b) && SvNVX(b) / SvNVX(b) != SvNVX(b) / SvNVX(b)) {
         *ld = *(INT2PTR(float128 *, SvIVX(SvRV(a)))) * _get_inf(SvNVX(b) > 0 ? 1 : -1);
         return obj_ref;
       }
#endif
       *ld = *(INT2PTR(float128 *, SvIVX(SvRV(a)))) * (float128)SvNVX(b);
        return obj_ref;
    }

    if(sv_isobject(b)) {
       const char *h = HvNAME(SvSTASH(SvRV(b)));
       if(strEQ(h, "Math::Float128")) {
        *ld = *(INT2PTR(float128 *, SvIVX(SvRV(a)))) * *(INT2PTR(float128 *, SvIVX(SvRV(b))));
        return obj_ref;
      }
      croak("Invalid object supplied to Math::Float128::_overload_mul function");
    }
    croak("Invalid argument supplied to Math::Float128::_overload_mul function");
}

SV * _overload_sub(pTHX_ SV * a, SV * b, SV * third) {
     float128 * ld;
     SV * obj_ref, * obj;

     Newx(ld, 1, float128);
     if(ld == NULL) croak("Failed to allocate memory in _overload_sub function");

     obj_ref = newSV(0);
     obj = newSVrv(obj_ref, "Math::Float128");

     sv_setiv(obj, INT2PTR(IV,ld));
     SvREADONLY_on(obj);

    if(SvUOK(b)) {
       if(third == &PL_sv_yes) *ld = (float128)SvUVX(b) - *(INT2PTR(float128 *, SvIVX(SvRV(a))));
       else *ld = *(INT2PTR(float128 *, SvIVX(SvRV(a)))) - (float128)SvUVX(b);
       return obj_ref;
    }

    if(SvIOK(b)) {
       if(third == &PL_sv_yes) *ld = (float128)SvIVX(b) - *(INT2PTR(float128 *, SvIVX(SvRV(a))));
       else *ld = *(INT2PTR(float128 *, SvIVX(SvRV(a)))) - (float128)SvIVX(b);
       return obj_ref;
    }

    if(SvPOK(b)) {
       char * p;
#ifdef _WIN32_BIZARRE_INFNAN
       int inf_or_nan = _win32_infnanstring(SvPV_nolen(b));
#endif

       NOK_POK_DUALVAR_CHECK , "overload_sub");}

#ifdef _WIN32_BIZARRE_INFNAN
       if(inf_or_nan) {
         if(inf_or_nan == 2) *ld = _get_nan();
         else {
           if(third == &PL_sv_yes) *ld = _get_inf(inf_or_nan) - *(INT2PTR(float128 *, SvIVX(SvRV(a))));
           else *ld = *(INT2PTR(float128 *, SvIVX(SvRV(a)))) - _get_inf(inf_or_nan);
         }
       }
       else {
         if(third == &PL_sv_yes) *ld = strtoflt128(SvPV_nolen(b), &p) - *(INT2PTR(float128 *, SvIVX(SvRV(a))));
         else *ld = *(INT2PTR(float128 *, SvIVX(SvRV(a)))) - strtoflt128(SvPV_nolen(b), &p);
         _nnum_inc(p);
       }
#else
       if(third == &PL_sv_yes) *ld = strtoflt128(SvPV_nolen(b), &p) - *(INT2PTR(float128 *, SvIVX(SvRV(a))));
       else *ld = *(INT2PTR(float128 *, SvIVX(SvRV(a)))) - strtoflt128(SvPV_nolen(b), &p);
       _nnum_inc(p);
#endif
       return obj_ref;
    }

    if(SvNOK(b)) {
#if defined(AVOID_INF_CAST)
       if(SvNVX(b) != 0.0L && SvNVX(b) == SvNVX(b) && SvNVX(b) / SvNVX(b) != SvNVX(b) / SvNVX(b)) {
         if(third == &PL_sv_yes) *ld = _get_inf(SvNVX(b) > 0 ? 1 : -1) - *(INT2PTR(float128 *, SvIVX(SvRV(a))));
         else *ld = *(INT2PTR(float128 *, SvIVX(SvRV(a)))) - _get_inf(SvNVX(b) > 0 ? 1 : -1);
         return obj_ref;
       }
#endif
       if(third == &PL_sv_yes) *ld = (float128)SvNVX(b) - *(INT2PTR(float128 *, SvIVX(SvRV(a))));
       else *ld = *(INT2PTR(float128 *, SvIVX(SvRV(a)))) - (float128)SvNVX(b);
       return obj_ref;
    }

    if(sv_isobject(b)) {
       const char *h = HvNAME(SvSTASH(SvRV(b)));
       if(strEQ(h, "Math::Float128")) {
        *ld = *(INT2PTR(float128 *, SvIVX(SvRV(a)))) - *(INT2PTR(float128 *, SvIVX(SvRV(b))));
        return obj_ref;
      }
      croak("Invalid object supplied to Math::Float128::_overload_sub function");
    }

    /*
    else {
      if(third == &PL_sv_yes) {
        *ld = *(INT2PTR(float128 *, SvIVX(SvRV(a)))) * -1.0L;
        return obj_ref;
      }
    }
    */

    croak("Invalid argument supplied to Math::Float128::_overload_sub function");

}

SV * _overload_div(pTHX_ SV * a, SV * b, SV * third) {
     float128 * ld;
     SV * obj_ref, * obj;

     Newx(ld, 1, float128);
     if(ld == NULL) croak("Failed to allocate memory in _overload_div function");

     obj_ref = newSV(0);
     obj = newSVrv(obj_ref, "Math::Float128");

     sv_setiv(obj, INT2PTR(IV,ld));
     SvREADONLY_on(obj);

    if(SvUOK(b)) {
       if(third == &PL_sv_yes) *ld = (float128)SvUVX(b) / *(INT2PTR(float128 *, SvIVX(SvRV(a))));
       else *ld = *(INT2PTR(float128 *, SvIVX(SvRV(a)))) / (float128)SvUVX(b);
       return obj_ref;
    }

    if(SvIOK(b)) {
       if(third == &PL_sv_yes) *ld = (float128)SvIVX(b) / *(INT2PTR(float128 *, SvIVX(SvRV(a))));
       else *ld = *(INT2PTR(float128 *, SvIVX(SvRV(a)))) / (float128)SvIVX(b);
       return obj_ref;
    }

    if(SvPOK(b)) {
       char * p;
#ifdef _WIN32_BIZARRE_INFNAN
       int inf_or_nan = _win32_infnanstring(SvPV_nolen(b));
#endif

       NOK_POK_DUALVAR_CHECK , "overload_div");}

#ifdef _WIN32_BIZARRE_INFNAN
       if(inf_or_nan) {
         if(inf_or_nan == 2) *ld = _get_nan();
         else {
           if(third == &PL_sv_yes) *ld = _get_inf(inf_or_nan) / *(INT2PTR(float128 *, SvIVX(SvRV(a))));
           else *ld = *(INT2PTR(float128 *, SvIVX(SvRV(a)))) / _get_inf(inf_or_nan);
         }
       }
       else {
         if(third == &PL_sv_yes) *ld = strtoflt128(SvPV_nolen(b), &p) / *(INT2PTR(float128 *, SvIVX(SvRV(a))));
         else *ld = *(INT2PTR(float128 *, SvIVX(SvRV(a)))) / strtoflt128(SvPV_nolen(b), &p);
         _nnum_inc(p);
       }
#else
       if(third == &PL_sv_yes) *ld = strtoflt128(SvPV_nolen(b), &p) / *(INT2PTR(float128 *, SvIVX(SvRV(a))));
       else *ld = *(INT2PTR(float128 *, SvIVX(SvRV(a)))) / strtoflt128(SvPV_nolen(b), &p);
       _nnum_inc(p);
#endif
       return obj_ref;
    }

    if(SvNOK(b)) {
#if defined(AVOID_INF_CAST)
       if(SvNVX(b) != 0.0L && SvNVX(b) == SvNVX(b) && SvNVX(b) / SvNVX(b) != SvNVX(b) / SvNVX(b)) {
         if(third == &PL_sv_yes) *ld = _get_inf(SvNVX(b) > 0 ? 1 : -1) / *(INT2PTR(float128 *, SvIVX(SvRV(a))));
         else *ld = *(INT2PTR(float128 *, SvIVX(SvRV(a)))) / _get_inf(SvNVX(b) > 0 ? 1 : -1);
         return obj_ref;
       }
#endif
       if(third == &PL_sv_yes) *ld = (float128)SvNVX(b) / *(INT2PTR(float128 *, SvIVX(SvRV(a))));
       else *ld = *(INT2PTR(float128 *, SvIVX(SvRV(a)))) / (float128)SvNVX(b);
       return obj_ref;
    }

    if(sv_isobject(b)) {
       const char *h = HvNAME(SvSTASH(SvRV(b)));
       if(strEQ(h, "Math::Float128")) {
        *ld = *(INT2PTR(float128 *, SvIVX(SvRV(a)))) / *(INT2PTR(float128 *, SvIVX(SvRV(b))));
        return obj_ref;
      }
      croak("Invalid object supplied to Math::Float128::_overload_div function");
    }
    croak("Invalid argument supplied to Math::Float128::_overload_div function");
}

SV * _overload_equiv(pTHX_ SV * a, SV * b, SV * third) {

    if(SvUOK(b)) {
       if(*(INT2PTR(float128 *, SvIVX(SvRV(a)))) == (float128)SvUVX(b)) return newSViv(1);
        return newSViv(0);
    }

    if(SvIOK(b)) {
       if(*(INT2PTR(float128 *, SvIVX(SvRV(a)))) == (float128)SvIVX(b)) return newSViv(1);
        return newSViv(0);
    }

    if(SvPOK(b)) {
       char * p;
#ifdef _WIN32_BIZARRE_INFNAN
       int inf_or_nan = _win32_infnanstring(SvPV_nolen(b));
#endif

       NOK_POK_DUALVAR_CHECK , "overload_equiv");}

#ifdef _WIN32_BIZARRE_INFNAN
       if(inf_or_nan) {
         if(inf_or_nan == 2) return newSViv(0);
         else {
           if(*(INT2PTR(float128 *, SvIVX(SvRV(a)))) == _get_inf(inf_or_nan)) return newSViv(1);
           return newSViv(0);
         }
       }
       else {
         if(*(INT2PTR(float128 *, SvIVX(SvRV(a)))) == strtoflt128(SvPV_nolen(b), &p)) {
           _nnum_inc(p);
           return newSViv(1);
         }
         _nnum_inc(p);
         return newSViv(0);
       }
#else
       if(*(INT2PTR(float128 *, SvIVX(SvRV(a)))) == strtoflt128(SvPV_nolen(b), &p)) {
         _nnum_inc(p);
         return newSViv(1);
       }
       _nnum_inc(p);
       return newSViv(0);
#endif
    }

    if(SvNOK(b)) {
#if defined(AVOID_INF_CAST)
       if(SvNVX(b) != 0.0L && SvNVX(b) == SvNVX(b) && SvNVX(b) / SvNVX(b) != SvNVX(b) / SvNVX(b)) {
         if(*(INT2PTR(float128 *, SvIVX(SvRV(a)))) == _get_inf(SvNVX(b) > 0 ? 1 : -1))
           return newSViv(1);
         return newSViv(0);
       }
#endif
       if(*(INT2PTR(float128 *, SvIVX(SvRV(a)))) == (float128)SvNVX(b)) return newSViv(1);
        return newSViv(0);
    }

    if(sv_isobject(b)) {
      const char *h = HvNAME(SvSTASH(SvRV(b)));
      if(strEQ(h, "Math::Float128")) {
        if(*(INT2PTR(float128 *, SvIVX(SvRV(a)))) == *(INT2PTR(float128 *, SvIVX(SvRV(b))))) return newSViv(1);
        return newSViv(0);
      }
      croak("Invalid object supplied to Math::Float128::_overload_equiv function");
    }
    croak("Invalid argument supplied to Math::Float128::_overload_equiv function");
}

SV * _overload_not_equiv(pTHX_ SV * a, SV * b, SV * third) {

    if(SvUOK(b)) {
       if(*(INT2PTR(float128 *, SvIVX(SvRV(a)))) != (float128)SvUVX(b)) return newSViv(1);
        return newSViv(0);
    }

    if(SvIOK(b)) {
       if(*(INT2PTR(float128 *, SvIVX(SvRV(a)))) != (float128)SvIVX(b)) return newSViv(1);
        return newSViv(0);
    }

    if(SvPOK(b)) {
       char * p;
#ifdef _WIN32_BIZARRE_INFNAN
       int inf_or_nan = _win32_infnanstring(SvPV_nolen(b));
#endif

       NOK_POK_DUALVAR_CHECK , "overload_not_equiv");}

#ifdef _WIN32_BIZARRE_INFNAN
       if(inf_or_nan) {
         if(inf_or_nan == 2) return newSViv(1);
         else {
           if(*(INT2PTR(float128 *, SvIVX(SvRV(a)))) != _get_inf(inf_or_nan)) return newSViv(1);
           return newSViv(0);
         }
       }
       else {
         if(*(INT2PTR(float128 *, SvIVX(SvRV(a)))) != strtoflt128(SvPV_nolen(b), &p)) {
           _nnum_inc(p);
           return newSViv(1);
         }
         _nnum_inc(p);
         return newSViv(0);
       }
#else

       if(*(INT2PTR(float128 *, SvIVX(SvRV(a)))) != strtoflt128(SvPV_nolen(b), &p)) {
         _nnum_inc(p);
         return newSViv(1);
       }
       _nnum_inc(p);
       return newSViv(0);
#endif
    }

    if(SvNOK(b)) {
#if defined(AVOID_INF_CAST)
       if(SvNVX(b) != 0.0L && SvNVX(b) == SvNVX(b) && SvNVX(b) / SvNVX(b) != SvNVX(b) / SvNVX(b)) {
         if(*(INT2PTR(float128 *, SvIVX(SvRV(a)))) != _get_inf(SvNVX(b) > 0 ? 1 : -1))
           return newSViv(1);
         return newSViv(0);
       }
#endif
       if(*(INT2PTR(float128 *, SvIVX(SvRV(a)))) != (float128)SvNVX(b)) return newSViv(1);
        return newSViv(0);
    }

    if(sv_isobject(b)) {
      const char *h = HvNAME(SvSTASH(SvRV(b)));
      if(strEQ(h, "Math::Float128")) {
        if(*(INT2PTR(float128 *, SvIVX(SvRV(a)))) == *(INT2PTR(float128 *, SvIVX(SvRV(b))))) return newSViv(0);
        return newSViv(1);
      }
      croak("Invalid object supplied to Math::Float128::_overload_not_equiv function");
    }
    croak("Invalid argument supplied to Math::Float128::_overload_not_equiv function");
}

SV * _overload_true(pTHX_ SV * a, SV * b, SV * third) {

     if(_is_nan(*(INT2PTR(float128 *, SvIVX(SvRV(a)))))) return newSViv(0);
     if(*(INT2PTR(float128 *, SvIVX(SvRV(a)))) != 0.0Q) return newSViv(1);
     return newSViv(0);
}

SV * _overload_not(pTHX_ SV * a, SV * b, SV * third) {
     if(_is_nan(*(INT2PTR(float128 *, SvIVX(SvRV(a)))))) return newSViv(1);
     if(*(INT2PTR(float128 *, SvIVX(SvRV(a)))) != 0.0L) return newSViv(0);
     return newSViv(1);
}

SV * _overload_add_eq(pTHX_ SV * a, SV * b, SV * third) {

    SvREFCNT_inc(a);

    if(SvUOK(b)) {
       *(INT2PTR(float128 *, SvIVX(SvRV(a)))) += (float128)SvUVX(b);
        return a;
    }

    if(SvIOK(b)) {
       *(INT2PTR(float128 *, SvIVX(SvRV(a)))) += (float128)SvIVX(b);
        return a;
    }

    if(SvPOK(b)) {
       char * p;
#ifdef _WIN32_BIZARRE_INFNAN
       int inf_or_nan = _win32_infnanstring(SvPV_nolen(b));
#endif

       NOK_POK_DUALVAR_CHECK , "overload_add_eq");}

#ifdef _WIN32_BIZARRE_INFNAN

       if(inf_or_nan) {
         if(inf_or_nan == 2) {
           *(INT2PTR(float128 *, SvIVX(SvRV(a)))) = _get_nan();
           return a;
         }

         *(INT2PTR(float128 *, SvIVX(SvRV(a)))) += _get_inf(inf_or_nan);
         return a;
       }

       *(INT2PTR(float128 *, SvIVX(SvRV(a)))) += strtoflt128(SvPV_nolen(b), &p);
       _nnum_inc(p);
       return a;
#else

       *(INT2PTR(float128 *, SvIVX(SvRV(a)))) += strtoflt128(SvPV_nolen(b), &p);
       _nnum_inc(p);
       return a;
#endif
    }

    if(SvNOK(b)) {
#if defined(AVOID_INF_CAST)
       if(SvNVX(b) != 0.0L && SvNVX(b) == SvNVX(b) && SvNVX(b) / SvNVX(b) != SvNVX(b) / SvNVX(b)) {
         *(INT2PTR(float128 *, SvIVX(SvRV(a)))) += _get_inf(SvNVX(b) > 0 ? 1 : -1);
         return a;
       }
#endif
       *(INT2PTR(float128 *, SvIVX(SvRV(a)))) += (float128)SvNVX(b);
        return a;
    }

    if(sv_isobject(b)) {
       const char *h = HvNAME(SvSTASH(SvRV(b)));
       if(strEQ(h, "Math::Float128")) {
        *(INT2PTR(float128 *, SvIVX(SvRV(a)))) += *(INT2PTR(float128 *, SvIVX(SvRV(b))));
        return a;
      }
      SvREFCNT_dec(a);
      croak("Invalid object supplied to Math::Float128::_overload_add_eq function");
    }
    SvREFCNT_dec(a);
    croak("Invalid argument supplied to Math::Float128::_overload_add_eq function");
}

SV * _overload_mul_eq(pTHX_ SV * a, SV * b, SV * third) {

    SvREFCNT_inc(a);

    if(SvUOK(b)) {
       *(INT2PTR(float128 *, SvIVX(SvRV(a)))) *= (float128)SvUVX(b);
        return a;
    }

    if(SvIOK(b)) {
       *(INT2PTR(float128 *, SvIVX(SvRV(a)))) *= (float128)SvIVX(b);
        return a;
    }

    if(SvPOK(b)) {
       char * p;
#ifdef _WIN32_BIZARRE_INFNAN
       int inf_or_nan = _win32_infnanstring(SvPV_nolen(b));
#endif

       NOK_POK_DUALVAR_CHECK , "overload_mul_eq");}

#ifdef _WIN32_BIZARRE_INFNAN

       if(inf_or_nan) {
         if(inf_or_nan == 2) {
           *(INT2PTR(float128 *, SvIVX(SvRV(a)))) = _get_nan();
           return a;
         }

         *(INT2PTR(float128 *, SvIVX(SvRV(a)))) *= _get_inf(inf_or_nan);
         return a;
       }

       *(INT2PTR(float128 *, SvIVX(SvRV(a)))) *= strtoflt128(SvPV_nolen(b), &p);
       _nnum_inc(p);
       return a;
#else

       *(INT2PTR(float128 *, SvIVX(SvRV(a)))) *= strtoflt128(SvPV_nolen(b), &p);
       _nnum_inc(p);
       return a;
#endif
    }

    if(SvNOK(b)) {
#if defined(AVOID_INF_CAST)
       if(SvNVX(b) != 0.0L && SvNVX(b) == SvNVX(b) && SvNVX(b) / SvNVX(b) != SvNVX(b) / SvNVX(b)) {
         *(INT2PTR(float128 *, SvIVX(SvRV(a)))) *= _get_inf(SvNVX(b) > 0 ? 1 : -1);
         return a;
       }
#endif
       *(INT2PTR(float128 *, SvIVX(SvRV(a)))) *= (float128)SvNVX(b);
        return a;
    }

    if(sv_isobject(b)) {
       const char *h = HvNAME(SvSTASH(SvRV(b)));
       if(strEQ(h, "Math::Float128")) {
        *(INT2PTR(float128 *, SvIVX(SvRV(a)))) *= *(INT2PTR(float128 *, SvIVX(SvRV(b))));
        return a;
      }
      SvREFCNT_dec(a);
      croak("Invalid object supplied to Math::Float128::_overload_mul_eq function");
    }
    SvREFCNT_dec(a);
    croak("Invalid argument supplied to Math::Float128::_overload_mul_eq function");
}

SV * _overload_sub_eq(pTHX_ SV * a, SV * b, SV * third) {

    SvREFCNT_inc(a);

    if(SvUOK(b)) {
       *(INT2PTR(float128 *, SvIVX(SvRV(a)))) -= (float128)SvUVX(b);
        return a;
    }

    if(SvIOK(b)) {
       *(INT2PTR(float128 *, SvIVX(SvRV(a)))) -= (float128)SvIVX(b);
        return a;
    }

    if(SvPOK(b)) {
       char * p;
#ifdef _WIN32_BIZARRE_INFNAN
       int inf_or_nan = _win32_infnanstring(SvPV_nolen(b));
#endif

       NOK_POK_DUALVAR_CHECK , "overload_sub_eq");}

#ifdef _WIN32_BIZARRE_INFNAN

       if(inf_or_nan) {
         if(inf_or_nan == 2) {
           *(INT2PTR(float128 *, SvIVX(SvRV(a)))) = _get_nan();
           return a;
         }

         *(INT2PTR(float128 *, SvIVX(SvRV(a)))) -= _get_inf(inf_or_nan);
         return a;
       }

       *(INT2PTR(float128 *, SvIVX(SvRV(a)))) -= strtoflt128(SvPV_nolen(b), &p);
       _nnum_inc(p);
       return a;
#else

       *(INT2PTR(float128 *, SvIVX(SvRV(a)))) -= strtoflt128(SvPV_nolen(b), &p);
       _nnum_inc(p);
       return a;
#endif
    }


    if(SvNOK(b)) {
#if defined(AVOID_INF_CAST)
       if(SvNVX(b) != 0.0L && SvNVX(b) == SvNVX(b) && SvNVX(b) / SvNVX(b) != SvNVX(b) / SvNVX(b)) {
         *(INT2PTR(float128 *, SvIVX(SvRV(a)))) -= _get_inf(SvNVX(b) > 0 ? 1 : -1);
         return a;
       }
#endif
       *(INT2PTR(float128 *, SvIVX(SvRV(a)))) -= (float128)SvNVX(b);
        return a;
    }

    if(sv_isobject(b)) {
       const char *h = HvNAME(SvSTASH(SvRV(b)));
       if(strEQ(h, "Math::Float128")) {
        *(INT2PTR(float128 *, SvIVX(SvRV(a)))) -= *(INT2PTR(float128 *, SvIVX(SvRV(b))));
        return a;
      }
      SvREFCNT_dec(a);
      croak("Invalid object supplied to Math::Float128::_overload_sub_eq function");
    }
    SvREFCNT_dec(a);
    croak("Invalid argument supplied to Math::Float128::_overload_sub_eq function");
}

SV * _overload_div_eq(pTHX_ SV * a, SV * b, SV * third) {

    SvREFCNT_inc(a);

    if(SvUOK(b)) {
       *(INT2PTR(float128 *, SvIVX(SvRV(a)))) /= (float128)SvUVX(b);
        return a;
    }

    if(SvIOK(b)) {
       *(INT2PTR(float128 *, SvIVX(SvRV(a)))) /= (float128)SvIVX(b);
        return a;
    }

    if(SvPOK(b)) {
       char * p;
#ifdef _WIN32_BIZARRE_INFNAN
       int inf_or_nan = _win32_infnanstring(SvPV_nolen(b));
#endif

       NOK_POK_DUALVAR_CHECK , "overload_div_eq");}

#ifdef _WIN32_BIZARRE_INFNAN

       if(inf_or_nan) {
         if(inf_or_nan == 2) {
           *(INT2PTR(float128 *, SvIVX(SvRV(a)))) = _get_nan();
           return a;
         }

         *(INT2PTR(float128 *, SvIVX(SvRV(a)))) /= _get_inf(inf_or_nan);
         return a;
       }

       *(INT2PTR(float128 *, SvIVX(SvRV(a)))) /= strtoflt128(SvPV_nolen(b), &p);
       _nnum_inc(p);
       return a;
#else

       *(INT2PTR(float128 *, SvIVX(SvRV(a)))) /= strtoflt128(SvPV_nolen(b), &p);
       _nnum_inc(p);
       return a;
#endif
    }

    if(SvNOK(b)) {
#if defined(AVOID_INF_CAST)
       if(SvNVX(b) != 0.0L && SvNVX(b) == SvNVX(b) && SvNVX(b) / SvNVX(b) != SvNVX(b) / SvNVX(b)) {
         *(INT2PTR(float128 *, SvIVX(SvRV(a)))) /= _get_inf(SvNVX(b) > 0 ? 1 : -1);
         return a;
       }
#endif
       *(INT2PTR(float128 *, SvIVX(SvRV(a)))) /= (float128)SvNVX(b);
        return a;
    }

    if(sv_isobject(b)) {
       const char *h = HvNAME(SvSTASH(SvRV(b)));
       if(strEQ(h, "Math::Float128")) {
        *(INT2PTR(float128 *, SvIVX(SvRV(a)))) /= *(INT2PTR(float128 *, SvIVX(SvRV(b))));
        return a;
      }
      SvREFCNT_dec(a);
      croak("Invalid object supplied to Math::Float128::_overload_div_eq function");
    }
    SvREFCNT_dec(a);
    croak("Invalid argument supplied to Math::Float128::_overload_div_eq function");
}

SV * _overload_lt(pTHX_ SV * a, SV * b, SV * third) {

    if(SvUOK(b)) {
      if(third == &PL_sv_yes) {
        if(*(INT2PTR(float128 *, SvIVX(SvRV(a)))) > (float128)SvUVX(b)) return newSViv(1);
        return newSViv(0);
      }
      if(*(INT2PTR(float128 *, SvIVX(SvRV(a)))) < (float128)SvUVX(b)) return newSViv(1);
      return newSViv(0);
    }

    if(SvIOK(b)) {
      if(third == &PL_sv_yes) {
        if(*(INT2PTR(float128 *, SvIVX(SvRV(a)))) > (float128)SvIVX(b)) return newSViv(1);
        return newSViv(0);
      }
      if(*(INT2PTR(float128 *, SvIVX(SvRV(a)))) < (float128)SvIVX(b)) return newSViv(1);
      return newSViv(0);
    }

    if(SvPOK(b)) {
      char * p;
#ifdef _WIN32_BIZARRE_INFNAN
       int inf_or_nan = _win32_infnanstring(SvPV_nolen(b));
#endif

      NOK_POK_DUALVAR_CHECK , "overload_lt");}

#ifdef _WIN32_BIZARRE_INFNAN
      if(inf_or_nan) {
        if(inf_or_nan == 2) return newSViv(0);
        if(third == &PL_sv_yes) {
          if(*(INT2PTR(float128 *, SvIVX(SvRV(a)))) > _get_inf(inf_or_nan)) return newSViv(1);
          return newSViv(0);
        }
        if(*(INT2PTR(float128 *, SvIVX(SvRV(a)))) < _get_inf(inf_or_nan)) return newSViv(1);
        return newSViv(0);
      }
      if(third == &PL_sv_yes) {
        if(*(INT2PTR(float128 *, SvIVX(SvRV(a)))) > strtoflt128(SvPV_nolen(b), &p)) {
          _nnum_inc(p);
          return newSViv(1);
        }
        _nnum_inc(p);
        return newSViv(0);
      }

      if(*(INT2PTR(float128 *, SvIVX(SvRV(a)))) < strtoflt128(SvPV_nolen(b), &p)) {
        _nnum_inc(p);
        return newSViv(1);
      }
      _nnum_inc(p);
      return newSViv(0);
#else

      if(third == &PL_sv_yes) {
        if(*(INT2PTR(float128 *, SvIVX(SvRV(a)))) > strtoflt128(SvPV_nolen(b), &p)) {
          _nnum_inc(p);
          return newSViv(1);
        }
        _nnum_inc(p);
        return newSViv(0);
      }

      if(*(INT2PTR(float128 *, SvIVX(SvRV(a)))) < strtoflt128(SvPV_nolen(b), &p)) {
        _nnum_inc(p);
        return newSViv(1);
      }
      _nnum_inc(p);
      return newSViv(0);
#endif
    }

    if(SvNOK(b)) {
#if defined(AVOID_INF_CAST)
       if(SvNVX(b) != 0.0L && SvNVX(b) == SvNVX(b) && SvNVX(b) / SvNVX(b) != SvNVX(b) / SvNVX(b)) {
         if(third == &PL_sv_yes) {
           if(*(INT2PTR(float128 *, SvIVX(SvRV(a)))) > _get_inf(SvNVX(b) > 0 ? 1 : -1))
             return newSViv(1);
           return newSViv(0);
         }
         if(*(INT2PTR(float128 *, SvIVX(SvRV(a)))) < _get_inf(SvNVX(b) > 0 ? 1 : -1))
           return newSViv(1);
         return newSViv(0);
       }
#endif
      if(third == &PL_sv_yes) {
        if(*(INT2PTR(float128 *, SvIVX(SvRV(a)))) > (float128)SvNVX(b)) return newSViv(1);
        return newSViv(0);
      }
      if(*(INT2PTR(float128 *, SvIVX(SvRV(a)))) < (float128)SvNVX(b)) return newSViv(1);
      return newSViv(0);
    }

    if(sv_isobject(b)) {
      const char *h = HvNAME(SvSTASH(SvRV(b)));
      if(strEQ(h, "Math::Float128")) {
        if(*(INT2PTR(float128 *, SvIVX(SvRV(a)))) < *(INT2PTR(float128 *, SvIVX(SvRV(b))))) return newSViv(1);
        return newSViv(0);
      }
      croak("Invalid object supplied to Math::Float128::_overload_lt function");
    }
    croak("Invalid argument supplied to Math::Float128::_overload_lt function");
}

SV * _overload_gt(pTHX_ SV * a, SV * b, SV * third) {

    if(SvUOK(b)) {
      if(third == &PL_sv_yes) {
        if(*(INT2PTR(float128 *, SvIVX(SvRV(a)))) < (float128)SvUVX(b)) return newSViv(1);
        return newSViv(0);
      }
      if(*(INT2PTR(float128 *, SvIVX(SvRV(a)))) > (float128)SvUVX(b)) return newSViv(1);
      return newSViv(0);
    }

    if(SvIOK(b)) {
      if(third == &PL_sv_yes) {
        if(*(INT2PTR(float128 *, SvIVX(SvRV(a)))) < (float128)SvIVX(b)) return newSViv(1);
        return newSViv(0);
      }
      if(*(INT2PTR(float128 *, SvIVX(SvRV(a)))) > (float128)SvIVX(b)) return newSViv(1);
      return newSViv(0);
    }

    if(SvPOK(b)) {
      char * p;
#ifdef _WIN32_BIZARRE_INFNAN
       int inf_or_nan = _win32_infnanstring(SvPV_nolen(b));
#endif

      NOK_POK_DUALVAR_CHECK , "overload_gt");}

#ifdef _WIN32_BIZARRE_INFNAN
      if(inf_or_nan) {
        if(inf_or_nan == 2) return newSViv(0);
        if(third == &PL_sv_yes) {
          if(*(INT2PTR(float128 *, SvIVX(SvRV(a)))) < _get_inf(inf_or_nan)) return newSViv(1);
          return newSViv(0);
        }
        if(*(INT2PTR(float128 *, SvIVX(SvRV(a)))) > _get_inf(inf_or_nan)) return newSViv(1);
        return newSViv(0);
      }
      if(third == &PL_sv_yes) {
        if(*(INT2PTR(float128 *, SvIVX(SvRV(a)))) < strtoflt128(SvPV_nolen(b), &p)) {
          _nnum_inc(p);
          return newSViv(1);
        }
        _nnum_inc(p);
        return newSViv(0);
      }

      if(*(INT2PTR(float128 *, SvIVX(SvRV(a)))) > strtoflt128(SvPV_nolen(b), &p)) {
        _nnum_inc(p);
        return newSViv(1);
      }
      _nnum_inc(p);
      return newSViv(0);
#else
      if(third == &PL_sv_yes) {
        if(*(INT2PTR(float128 *, SvIVX(SvRV(a)))) < strtoflt128(SvPV_nolen(b), &p)) {
          _nnum_inc(p);
          return newSViv(1);
        }
        _nnum_inc(p);
        return newSViv(0);
      }

      if(*(INT2PTR(float128 *, SvIVX(SvRV(a)))) > strtoflt128(SvPV_nolen(b), &p)) {
        _nnum_inc(p);
        return newSViv(1);
      }
      _nnum_inc(p);
      return newSViv(0);
#endif
    }

    if(SvNOK(b)) {
#if defined(AVOID_INF_CAST)
       if(SvNVX(b) != 0.0L && SvNVX(b) == SvNVX(b) && SvNVX(b) / SvNVX(b) != SvNVX(b) / SvNVX(b)) {
         if(third == &PL_sv_yes) {
           if(*(INT2PTR(float128 *, SvIVX(SvRV(a)))) < _get_inf(SvNVX(b) > 0 ? 1 : -1))
             return newSViv(1);
           return newSViv(0);
         }
         if(*(INT2PTR(float128 *, SvIVX(SvRV(a)))) > _get_inf(SvNVX(b) > 0 ? 1 : -1))
           return newSViv(1);
         return newSViv(0);
       }
#endif
      if(third == &PL_sv_yes) {
        if(*(INT2PTR(float128 *, SvIVX(SvRV(a)))) < (float128)SvNVX(b)) return newSViv(1);
        return newSViv(0);
      }
      if(*(INT2PTR(float128 *, SvIVX(SvRV(a)))) > (float128)SvNVX(b)) return newSViv(1);
      return newSViv(0);
    }

    if(sv_isobject(b)) {
      const char *h = HvNAME(SvSTASH(SvRV(b)));
      if(strEQ(h, "Math::Float128")) {
        if(*(INT2PTR(float128 *, SvIVX(SvRV(a)))) > *(INT2PTR(float128 *, SvIVX(SvRV(b))))) return newSViv(1);
        return newSViv(0);
      }
      croak("Invalid object supplied to Math::Float128::_overload_gt function");
    }
     croak("Invalid argument supplied to Math::Float128::_overload_gt function");
}

SV * _overload_lte(pTHX_ SV * a, SV * b, SV * third) {

    if(SvUOK(b)) {
      if(third == &PL_sv_yes) {
        if(*(INT2PTR(float128 *, SvIVX(SvRV(a)))) >= (float128)SvUVX(b)) return newSViv(1);
        return newSViv(0);
      }
      if(*(INT2PTR(float128 *, SvIVX(SvRV(a)))) <= (float128)SvUVX(b)) return newSViv(1);
      return newSViv(0);
    }

    if(SvIOK(b)) {
      if(third == &PL_sv_yes) {
        if(*(INT2PTR(float128 *, SvIVX(SvRV(a)))) >= (float128)SvIVX(b)) return newSViv(1);
        return newSViv(0);
      }
      if(*(INT2PTR(float128 *, SvIVX(SvRV(a)))) <= (float128)SvIVX(b)) return newSViv(1);
      return newSViv(0);
    }

    if(SvPOK(b)) {
      char * p;
#ifdef _WIN32_BIZARRE_INFNAN
       int inf_or_nan = _win32_infnanstring(SvPV_nolen(b));
#endif

      NOK_POK_DUALVAR_CHECK , "overload_lte");}

#ifdef _WIN32_BIZARRE_INFNAN
      if(inf_or_nan) {
        if(inf_or_nan == 2) return newSViv(0);
        if(third == &PL_sv_yes) {
          if(*(INT2PTR(float128 *, SvIVX(SvRV(a)))) >= _get_inf(inf_or_nan)) return newSViv(1);
          return newSViv(0);
        }
        if(*(INT2PTR(float128 *, SvIVX(SvRV(a)))) <= _get_inf(inf_or_nan)) return newSViv(1);
        return newSViv(0);
      }
      if(third == &PL_sv_yes) {
        if(*(INT2PTR(float128 *, SvIVX(SvRV(a)))) >= strtoflt128(SvPV_nolen(b), &p)) {
          _nnum_inc(p);
          return newSViv(1);
        }
        _nnum_inc(p);
        return newSViv(0);
      }

      if(*(INT2PTR(float128 *, SvIVX(SvRV(a)))) <= strtoflt128(SvPV_nolen(b), &p)) {
        _nnum_inc(p);
        return newSViv(1);
      }
      _nnum_inc(p);
      return newSViv(0);
#else
      if(third == &PL_sv_yes) {
        if(*(INT2PTR(float128 *, SvIVX(SvRV(a)))) >= strtoflt128(SvPV_nolen(b), &p)) {
          _nnum_inc(p);
          return newSViv(1);
        }
        _nnum_inc(p);
        return newSViv(0);
      }
      if(*(INT2PTR(float128 *, SvIVX(SvRV(a)))) <= strtoflt128(SvPV_nolen(b), &p)) {
        _nnum_inc(p);
        return newSViv(1);
      }
      _nnum_inc(p);
      return newSViv(0);
#endif
    }

    if(SvNOK(b)) {
#if defined(AVOID_INF_CAST)
       if(SvNVX(b) != 0.0L && SvNVX(b) == SvNVX(b) && SvNVX(b) / SvNVX(b) != SvNVX(b) / SvNVX(b)) {
         if(third == &PL_sv_yes) {
           if(*(INT2PTR(float128 *, SvIVX(SvRV(a)))) >= _get_inf(SvNVX(b) > 0 ? 1 : -1))
             return newSViv(1);
           return newSViv(0);
         }
         if(*(INT2PTR(float128 *, SvIVX(SvRV(a)))) <= _get_inf(SvNVX(b) > 0 ? 1 : -1))
           return newSViv(1);
         return newSViv(0);
       }
#endif
      if(third == &PL_sv_yes) {
        if(*(INT2PTR(float128 *, SvIVX(SvRV(a)))) >= (float128)SvNVX(b)) return newSViv(1);
        return newSViv(0);
      }
      if(*(INT2PTR(float128 *, SvIVX(SvRV(a)))) <= (float128)SvNVX(b)) return newSViv(1);
      return newSViv(0);
    }

    if(sv_isobject(b)) {
      const char *h = HvNAME(SvSTASH(SvRV(b)));
      if(strEQ(h, "Math::Float128")) {
        if(*(INT2PTR(float128 *, SvIVX(SvRV(a)))) <= *(INT2PTR(float128 *, SvIVX(SvRV(b))))) return newSViv(1);
        return newSViv(0);
      }
      croak("Invalid object supplied to Math::Float128::_overload_lte function");
    }
    croak("Invalid argument supplied to Math::Float128::_overload_lte function");
}

SV * _overload_gte(pTHX_ SV * a, SV * b, SV * third) {

    if(SvUOK(b)) {
      if(third == &PL_sv_yes) {
        if(*(INT2PTR(float128 *, SvIVX(SvRV(a)))) <= (float128)SvUVX(b)) return newSViv(1);
        return newSViv(0);
      }
      if(*(INT2PTR(float128 *, SvIVX(SvRV(a)))) >= (float128)SvUVX(b)) return newSViv(1);
      return newSViv(0);
    }

    if(SvIOK(b)) {
      if(third == &PL_sv_yes) {
        if(*(INT2PTR(float128 *, SvIVX(SvRV(a)))) <= (float128)SvIVX(b)) return newSViv(1);
        return newSViv(0);
      }
      if(*(INT2PTR(float128 *, SvIVX(SvRV(a)))) >= (float128)SvIVX(b)) return newSViv(1);
      return newSViv(0);
    }

    if(SvPOK(b)) {
      char * p;
#ifdef _WIN32_BIZARRE_INFNAN
       int inf_or_nan = _win32_infnanstring(SvPV_nolen(b));
#endif

      NOK_POK_DUALVAR_CHECK , "overload_gte");}

#ifdef _WIN32_BIZARRE_INFNAN
      if(inf_or_nan) {
        if(inf_or_nan == 2) return newSViv(0);
        if(third == &PL_sv_yes) {
          if(*(INT2PTR(float128 *, SvIVX(SvRV(a)))) <= _get_inf(inf_or_nan)) return newSViv(1);
          return newSViv(0);
        }
        if(*(INT2PTR(float128 *, SvIVX(SvRV(a)))) >= _get_inf(inf_or_nan)) return newSViv(1);
        return newSViv(0);
      }
      if(third == &PL_sv_yes) {
        if(*(INT2PTR(float128 *, SvIVX(SvRV(a)))) <= strtoflt128(SvPV_nolen(b), &p)) {
          _nnum_inc(p);
          return newSViv(1);
        }
        _nnum_inc(p);
        return newSViv(0);
      }

      if(*(INT2PTR(float128 *, SvIVX(SvRV(a)))) >= strtoflt128(SvPV_nolen(b), &p)) {
        _nnum_inc(p);
        return newSViv(1);
      }
      _nnum_inc(p);
      return newSViv(0);
#else

      if(third == &PL_sv_yes) {
        if(*(INT2PTR(float128 *, SvIVX(SvRV(a)))) <= strtoflt128(SvPV_nolen(b), &p)) {
          _nnum_inc(p);
          return newSViv(1);
        }
        _nnum_inc(p);
        return newSViv(0);
      }

      if(*(INT2PTR(float128 *, SvIVX(SvRV(a)))) >= strtoflt128(SvPV_nolen(b), &p)) {
        _nnum_inc(p);
        return newSViv(1);
      }
      _nnum_inc(p);
      return newSViv(0);
#endif
    }


    if(SvNOK(b)) {
#if defined(AVOID_INF_CAST)
       if(SvNVX(b) != 0.0L && SvNVX(b) == SvNVX(b) && SvNVX(b) / SvNVX(b) != SvNVX(b) / SvNVX(b)) {
         if(third == &PL_sv_yes) {
           if(*(INT2PTR(float128 *, SvIVX(SvRV(a)))) <= _get_inf(SvNVX(b) > 0 ? 1 : -1))
             return newSViv(1);
           return newSViv(0);
         }
         if(*(INT2PTR(float128 *, SvIVX(SvRV(a)))) >= _get_inf(SvNVX(b) > 0 ? 1 : -1))
           return newSViv(1);
         return newSViv(0);
       }
#endif
      if(third == &PL_sv_yes) {
        if(*(INT2PTR(float128 *, SvIVX(SvRV(a)))) <= (float128)SvNVX(b)) return newSViv(1);
        return newSViv(0);
      }
      if(*(INT2PTR(float128 *, SvIVX(SvRV(a)))) >= (float128)SvNVX(b)) return newSViv(1);
      return newSViv(0);
    }

    if(sv_isobject(b)) {
      const char *h = HvNAME(SvSTASH(SvRV(b)));
      if(strEQ(h, "Math::Float128")) {
        if(*(INT2PTR(float128 *, SvIVX(SvRV(a)))) >= *(INT2PTR(float128 *, SvIVX(SvRV(b))))) return newSViv(1);
        return newSViv(0);
      }
      croak("Invalid object supplied to Math::Float128::_overload_gte function");
    }
    croak("Invalid argument supplied to Math::Float128::_overload_gte function");
}

SV * _overload_spaceship(pTHX_ SV * a, SV * b, SV * third) {
    int reversal = 1;
    if(third == &PL_sv_yes) reversal = -1;

    if(SvUOK(b)) {
       if(*(INT2PTR(float128 *, SvIVX(SvRV(a)))) == (float128)SvUVX(b)) return newSViv( 0 * reversal);
       if(*(INT2PTR(float128 *, SvIVX(SvRV(a)))) <  (float128)SvUVX(b)) return newSViv(-1 * reversal);
       if(*(INT2PTR(float128 *, SvIVX(SvRV(a)))) >  (float128)SvUVX(b)) return newSViv( 1 * reversal);
       return &PL_sv_undef; /* it's a nan */
    }

    if(SvIOK(b)) {
       if(*(INT2PTR(float128 *, SvIVX(SvRV(a)))) == (float128)SvIVX(b)) return newSViv( 0);
       if(*(INT2PTR(float128 *, SvIVX(SvRV(a)))) <  (float128)SvIVX(b)) return newSViv(-1 * reversal);
       if(*(INT2PTR(float128 *, SvIVX(SvRV(a)))) >  (float128)SvIVX(b)) return newSViv( 1 * reversal);
       return &PL_sv_undef; /* it's a nan */
    }

    if(SvPOK(b)) {
       char *p;
#ifdef _WIN32_BIZARRE_INFNAN
       int inf_or_nan = _win32_infnanstring(SvPV_nolen(b));
#endif

       NOK_POK_DUALVAR_CHECK , "overload_spaceship");}

#ifdef _WIN32_BIZARRE_INFNAN

       if(inf_or_nan) {
         if(inf_or_nan == 2) return &PL_sv_undef;
         if(*(INT2PTR(float128 *, SvIVX(SvRV(a)))) == _get_inf(inf_or_nan))
           return newSViv(0);
         if(*(INT2PTR(float128 *, SvIVX(SvRV(a)))) < _get_inf(inf_or_nan))
           return newSViv(-1 * reversal);
         return newSViv(reversal);
       }

       if(*(INT2PTR(float128 *, SvIVX(SvRV(a)))) == strtoflt128(SvPV_nolen(b), &p)) {
         _nnum_inc(p);
         return newSViv( 0);
       }
       if(*(INT2PTR(float128 *, SvIVX(SvRV(a)))) <  strtoflt128(SvPV_nolen(b), &p)) {
         _nnum_inc(p);
         return newSViv(-1 * reversal);
       }
       if(*(INT2PTR(float128 *, SvIVX(SvRV(a)))) >  strtoflt128(SvPV_nolen(b), &p)) {
         _nnum_inc(p);
         return newSViv(reversal);
       }
       return &PL_sv_undef; /* it's a nan */
#else
       if(*(INT2PTR(float128 *, SvIVX(SvRV(a)))) == strtoflt128(SvPV_nolen(b), &p)) {
         _nnum_inc(p);
         return newSViv( 0);
       }
       if(*(INT2PTR(float128 *, SvIVX(SvRV(a)))) <  strtoflt128(SvPV_nolen(b), &p)) {
         _nnum_inc(p);
         return newSViv(-1 * reversal);
       }
       if(*(INT2PTR(float128 *, SvIVX(SvRV(a)))) >  strtoflt128(SvPV_nolen(b), &p)) {
         _nnum_inc(p);
         return newSViv(reversal);
       }
       return &PL_sv_undef; /* it's a nan */
#endif
    }

    if(SvNOK(b)) {
#if defined(AVOID_INF_CAST)
       if(SvNVX(b) != 0.0L && SvNVX(b) == SvNVX(b) && SvNVX(b) / SvNVX(b) != SvNVX(b) / SvNVX(b)) {
         if(*(INT2PTR(float128 *, SvIVX(SvRV(a)))) == _get_inf(SvNVX(b) > 0 ? 1 : -1))
           return newSViv(0);
         if(*(INT2PTR(float128 *, SvIVX(SvRV(a)))) < _get_inf(SvNVX(b) > 0 ? 1 : -1))
           return newSViv(-1 * reversal);
         if(*(INT2PTR(float128 *, SvIVX(SvRV(a)))) > _get_inf(SvNVX(b) > 0 ? 1 : -1))
           return newSViv(reversal);
       }
#endif
       if(*(INT2PTR(float128 *, SvIVX(SvRV(a)))) == (float128)SvNVX(b)) return newSViv( 0);
       if(*(INT2PTR(float128 *, SvIVX(SvRV(a)))) <  (float128)SvNVX(b)) return newSViv(-1 * reversal);
       if(*(INT2PTR(float128 *, SvIVX(SvRV(a)))) >  (float128)SvNVX(b)) return newSViv(reversal);
       return &PL_sv_undef; /* it's a nan */
    }

    if(sv_isobject(b)) {
      const char *h = HvNAME(SvSTASH(SvRV(b)));
      if(strEQ(h, "Math::Float128")) {
        if(*(INT2PTR(float128 *, SvIVX(SvRV(a)))) < *(INT2PTR(float128 *, SvIVX(SvRV(b))))) return newSViv(-1);
        if(*(INT2PTR(float128 *, SvIVX(SvRV(a)))) > *(INT2PTR(float128 *, SvIVX(SvRV(b))))) return newSViv(1);
        if(*(INT2PTR(float128 *, SvIVX(SvRV(a)))) == *(INT2PTR(float128 *, SvIVX(SvRV(b))))) return newSViv(0);
        return &PL_sv_undef; /* it's a nan */
      }
      croak("Invalid object supplied to Math::Float128::_overload_spaceship function");
    }
    croak("Invalid argument supplied to Math::Float128::_overload_spaceship function");
}

SV * _overload_copy(pTHX_ SV * a, SV * b, SV * third) {

     float128 * ld;
     SV * obj_ref, * obj;

     Newx(ld, 1, float128);
     if(ld == NULL) croak("Failed to allocate memory in _overload_copy function");

     *ld = *(INT2PTR(float128 *, SvIVX(SvRV(a))));

     obj_ref = newSV(0);
     obj = newSVrv(obj_ref, "Math::Float128");
     sv_setiv(obj, INT2PTR(IV,ld));
     SvREADONLY_on(obj);
     return obj_ref;
}

SV * F128toF128(pTHX_ SV * a) {
     float128 * f;
     SV * obj_ref, * obj;

     if(sv_isobject(a)) {
       const char *h = HvNAME(SvSTASH(SvRV(a)));
       if(strEQ(h, "Math::Float128")) {

         Newx(f, 1, float128);
         if(f == NULL) croak("Failed to allocate memory in F128toF128 function");

         *f = *(INT2PTR(float128 *, SvIVX(SvRV(a))));

         obj_ref = newSV(0);
         obj = newSVrv(obj_ref, "Math::Float128");
         sv_setiv(obj, INT2PTR(IV,f));
         SvREADONLY_on(obj);
         return obj_ref;
       }
       croak("Invalid object supplied to Math::Float128::F128toF128 function");
     }
     croak("Invalid argument supplied to Math::Float128::F128toF128 function");
}

void fromF128(pTHX_ float128 * f, SV * a) {

     if(sv_isobject(a)) {
       const char *h = HvNAME(SvSTASH(SvRV(a)));
       if(strEQ(h, "Math::Float128")) {

         *f = *(INT2PTR(float128 *, SvIVX(SvRV(a))));
       }
       else croak("Invalid object supplied to Math::Float128::fromF128 function");
     }
     else croak("Invalid argument supplied to Math::Float128::fromF128 function");
}

SV * _itsa(pTHX_ SV * a) {
     if(SvUOK(a)) return newSVuv(1);
     if(SvIOK(a)) return newSVuv(2);
     if(SvPOK(a)) return newSVuv(4);
     if(SvNOK(a)) return newSVuv(3);
     if(sv_isobject(a)) {
       const char *h = HvNAME(SvSTASH(SvRV(a)));
       if(strEQ(h, "Math::Float128")) return newSVuv(113);
     }
     return newSVuv(0);
}

SV * _overload_abs(pTHX_ SV * a, SV * b, SV * third) {

     float128 * f;
     SV * obj_ref, * obj;

     Newx(f, 1, float128);
     if(f == NULL) croak("Failed to allocate memory in _overload_abs function");

     obj_ref = newSV(0);
     obj = newSVrv(obj_ref, "Math::Float128");

     sv_setiv(obj, INT2PTR(IV,f));
     SvREADONLY_on(obj);

     *f = fabsq(*(INT2PTR(float128 *, SvIVX(SvRV(a)))));
     return obj_ref;
}

SV * _overload_int(pTHX_ SV * a, SV * b, SV * third) {

     float128 * f;
     SV * obj_ref, * obj;

     Newx(f, 1, float128);
     if(f == NULL) croak("Failed to allocate memory in _overload_int function");

     *f = *(INT2PTR(float128 *, SvIVX(SvRV(a))));

     if(*f < 0.0Q) *f = ceilq(*f);
     else *f = floorq(*f);

     obj_ref = newSV(0);
     obj = newSVrv(obj_ref, "Math::Float128");
     sv_setiv(obj, INT2PTR(IV,f));
     SvREADONLY_on(obj);
     return obj_ref;
}

SV * _overload_sqrt(pTHX_ SV * a, SV * b, SV * third) {

     float128 * f;
     SV * obj_ref, * obj;

     Newx(f, 1, float128);
     if(f == NULL) croak("Failed to allocate memory in _overload_sqrt function");

     *f = sqrtq(*(INT2PTR(float128 *, SvIVX(SvRV(a)))));

     obj_ref = newSV(0);
     obj = newSVrv(obj_ref, "Math::Float128");
     sv_setiv(obj, INT2PTR(IV,f));
     SvREADONLY_on(obj);
     return obj_ref;
}

SV * _overload_log(pTHX_ SV * a, SV * b, SV * third) {

     float128 * f;
     SV * obj_ref, * obj;

     Newx(f, 1, float128);
     if(f == NULL) croak("Failed to allocate memory in _overload_log function");

     *f = logq(*(INT2PTR(float128 *, SvIVX(SvRV(a)))));


     obj_ref = newSV(0);
     obj = newSVrv(obj_ref, "Math::Float128");
     sv_setiv(obj, INT2PTR(IV,f));
     SvREADONLY_on(obj);
     return obj_ref;
}

SV * _overload_exp(pTHX_ SV * a, SV * b, SV * third) {

     float128 * f;
     SV * obj_ref, * obj;

     Newx(f, 1, float128);
     if(f == NULL) croak("Failed to allocate memory in _overload_exp function");

#if defined(__MINGW64_VERSION_MAJOR) && __MINGW64_VERSION_MAJOR < 4  /* avoid calling expq() as it's buggy */
     *f = powq(M_Eq, *(INT2PTR(float128 *, SvIVX(SvRV(a)))));
#else
     *f = expq(*(INT2PTR(float128 *, SvIVX(SvRV(a)))));
#endif


     obj_ref = newSV(0);
     obj = newSVrv(obj_ref, "Math::Float128");
     sv_setiv(obj, INT2PTR(IV,f));
     SvREADONLY_on(obj);
     return obj_ref;
}

SV * _overload_sin(pTHX_ SV * a, SV * b, SV * third) {

     float128 * f;
     SV * obj_ref, * obj;

     Newx(f, 1, float128);
     if(f == NULL) croak("Failed to allocate memory in _overload_sin function");

     *f = sinq(*(INT2PTR(float128 *, SvIVX(SvRV(a)))));


     obj_ref = newSV(0);
     obj = newSVrv(obj_ref, "Math::Float128");
     sv_setiv(obj, INT2PTR(IV,f));
     SvREADONLY_on(obj);
     return obj_ref;
}

SV * _overload_cos(pTHX_ SV * a, SV * b, SV * third) {

     float128 * f;
     SV * obj_ref, * obj;

     Newx(f, 1, float128);
     if(f == NULL) croak("Failed to allocate memory in _overload_cos function");

     *f = cosq(*(INT2PTR(float128 *, SvIVX(SvRV(a)))));


     obj_ref = newSV(0);
     obj = newSVrv(obj_ref, "Math::Float128");
     sv_setiv(obj, INT2PTR(IV,f));
     SvREADONLY_on(obj);
     return obj_ref;
}

SV * _overload_atan2(pTHX_ SV * a, SV * b, SV * third) {

     float128 * f;
     SV * obj_ref, * obj;

     Newx(f, 1, float128);
     if(f == NULL) croak("Failed to allocate memory in _overload_atan2 function");

     obj_ref = newSV(0);
     obj = newSVrv(obj_ref, "Math::Float128");
     sv_setiv(obj, INT2PTR(IV,f));
     SvREADONLY_on(obj);

     if(SvUOK(b)) {
       if(third == &PL_sv_yes)
            *f = atan2q((float128)SvUVX(b), *(INT2PTR(float128 *, SvIVX(SvRV(a)))));
       else *f = atan2q(*(INT2PTR(float128 *, SvIVX(SvRV(a)))), (float128)SvUVX(b));
       return obj_ref;
     }

     if(SvIOK(b)) {
       if(third == &PL_sv_yes)
            *f = atan2q((float128)SvIVX(b), *(INT2PTR(float128 *, SvIVX(SvRV(a)))));
       else *f = atan2q(*(INT2PTR(float128 *, SvIVX(SvRV(a)))), (float128)SvIVX(b));
       return obj_ref;
     }

     if(SvPOK(b)) {
       char * p;
#ifdef _WIN32_BIZARRE_INFNAN
       int inf_or_nan = _win32_infnanstring(SvPV_nolen(b));
#endif

       NOK_POK_DUALVAR_CHECK , "overload_atan2");}

#ifdef _WIN32_BIZARRE_INFNAN

       if(inf_or_nan) {
         if(inf_or_nan == 2) {
           if(third == &PL_sv_yes)
                *f = atan2q(_get_nan(), *(INT2PTR(float128 *, SvIVX(SvRV(a)))));
           else *f = atan2q(*(INT2PTR(float128 *, SvIVX(SvRV(a)))), _get_nan());
         }
         else {
           if(third == &PL_sv_yes)
                *f = atan2q(_get_inf(inf_or_nan), *(INT2PTR(float128 *, SvIVX(SvRV(a)))));
           else *f = atan2q(*(INT2PTR(float128 *, SvIVX(SvRV(a)))), _get_inf(inf_or_nan));
         }
       }
       else {
         if(third == &PL_sv_yes)
              *f = atan2q(strtoflt128(SvPV_nolen(b), &p), *(INT2PTR(float128 *, SvIVX(SvRV(a)))));
         else *f = atan2q(*(INT2PTR(float128 *, SvIVX(SvRV(a)))), strtoflt128(SvPV_nolen(b), &p));
         _nnum_inc(p);
         return obj_ref;
       }
#else
       if(third == &PL_sv_yes)
            *f = atan2q(strtoflt128(SvPV_nolen(b), &p), *(INT2PTR(float128 *, SvIVX(SvRV(a)))));
       else *f = atan2q(*(INT2PTR(float128 *, SvIVX(SvRV(a)))), strtoflt128(SvPV_nolen(b), &p));
       _nnum_inc(p);
       return obj_ref;
#endif
     }

     if(SvNOK(b)) {
#if defined(AVOID_INF_CAST)
       if(SvNVX(b) != 0.0L && SvNVX(b) == SvNVX(b) && SvNVX(b) / SvNVX(b) != SvNVX(b) / SvNVX(b)) {
         if(third == &PL_sv_yes)
              *f = atan2q(_get_inf(SvNVX(b) > 0 ? 1 : -1), *(INT2PTR(float128 *, SvIVX(SvRV(a)))));
         else *f = atan2q(*(INT2PTR(float128 *, SvIVX(SvRV(a)))), _get_inf(SvNVX(b) > 0 ? 1 : -1));
         return obj_ref;
       }
#endif
       if(third == &PL_sv_yes)
            *f = atan2q((float128)SvNVX(b), *(INT2PTR(float128 *, SvIVX(SvRV(a)))));
       else *f = atan2q(*(INT2PTR(float128 *, SvIVX(SvRV(a)))), (float128)SvNVX(b));
       return obj_ref;
     }

     if(sv_isobject(b)) {
       const char *h = HvNAME(SvSTASH(SvRV(b)));
       if(strEQ(h, "Math::Float128")) {
         *f = atan2q(*(INT2PTR(float128 *, SvIVX(SvRV(a)))), *(INT2PTR(float128 *, SvIVX(SvRV(b)))));
         return obj_ref;
       }
       croak("Invalid object supplied to Math::Float128::_overload_atan2 function");
     }
     croak("Invalid argument supplied to Math::Float128::_overload_atan2 function");
}

SV * _overload_inc(pTHX_ SV * a, SV * b, SV * third) {

     SvREFCNT_inc(a);

     *(INT2PTR(float128 *, SvIVX(SvRV(a)))) += 1.0Q;

     return a;
}

SV * _overload_dec(pTHX_ SV * a, SV * b, SV * third) {

     SvREFCNT_inc(a);

     *(INT2PTR(float128 *, SvIVX(SvRV(a)))) -= 1.0Q;

     return a;
}

SV * _overload_pow(pTHX_ SV * a, SV * b, SV * third) {

     float128 * f;
     SV * obj_ref, * obj;

     Newx(f, 1, float128);
     if(f == NULL) croak("Failed to allocate memory in _overload_pow function");

     obj_ref = newSV(0);
     obj = newSVrv(obj_ref, "Math::Float128");
     sv_setiv(obj, INT2PTR(IV,f));
     SvREADONLY_on(obj);

     if(SvUOK(b)) {
       if(third == &PL_sv_yes)
            *f = powq((float128)SvUVX(b), *(INT2PTR(float128 *, SvIVX(SvRV(a)))));
       else *f = powq(*(INT2PTR(float128 *, SvIVX(SvRV(a)))), (float128)SvUVX(b));
       return obj_ref;
     }

     if(SvIOK(b)) {
       if(third == &PL_sv_yes)
            *f = powq((float128)SvIVX(b), *(INT2PTR(float128 *, SvIVX(SvRV(a)))));
       else *f = powq(*(INT2PTR(float128 *, SvIVX(SvRV(a)))), (float128)SvIVX(b));
       return obj_ref;
     }

     if(SvPOK(b)) {
       char * p;
#ifdef _WIN32_BIZARRE_INFNAN
       int inf_or_nan = _win32_infnanstring(SvPV_nolen(b));
#endif

       NOK_POK_DUALVAR_CHECK , "overload_pow");}

#ifdef _WIN32_BIZARRE_INFNAN
       if(inf_or_nan) {
         if(inf_or_nan == 2) {
           if(third == &PL_sv_yes)
                *f = powq(_get_nan(), *(INT2PTR(float128 *, SvIVX(SvRV(a)))));
           else *f = powq(*(INT2PTR(float128 *, SvIVX(SvRV(a)))), _get_nan());
         }
         else {
           if(third == &PL_sv_yes)
                *f = powq(_get_inf(inf_or_nan), *(INT2PTR(float128 *, SvIVX(SvRV(a)))));
           else *f = powq(*(INT2PTR(float128 *, SvIVX(SvRV(a)))), _get_inf(inf_or_nan));
         }
       }
       else {
         if(third == &PL_sv_yes)
              *f = powq(strtoflt128(SvPV_nolen(b), &p), *(INT2PTR(float128 *, SvIVX(SvRV(a)))));
         else *f = powq(*(INT2PTR(float128 *, SvIVX(SvRV(a)))), strtoflt128(SvPV_nolen(b), &p));
         _nnum_inc(p);
       }
#else
       if(third == &PL_sv_yes)
            *f = powq(strtoflt128(SvPV_nolen(b), &p), *(INT2PTR(float128 *, SvIVX(SvRV(a)))));
       else *f = powq(*(INT2PTR(float128 *, SvIVX(SvRV(a)))), strtoflt128(SvPV_nolen(b), &p));
       _nnum_inc(p);
#endif
       return obj_ref;
     }

     if(SvNOK(b)) {
#if defined(AVOID_INF_CAST)
       if(SvNVX(b) != 0.0L && SvNVX(b) == SvNVX(b) && SvNVX(b) / SvNVX(b) != SvNVX(b) / SvNVX(b)) {
         if(third == &PL_sv_yes)
              *f = powq(_get_inf(SvNVX(b) > 0 ? 1 : -1), *(INT2PTR(float128 *, SvIVX(SvRV(a)))));
         else *f = powq(*(INT2PTR(float128 *, SvIVX(SvRV(a)))), _get_inf(SvNVX(b) > 0 ? 1 : -1));
         return obj_ref;
       }
#endif
       if(third == &PL_sv_yes)
            *f = powq((float128)SvNVX(b), *(INT2PTR(float128 *, SvIVX(SvRV(a)))));
       else *f = powq(*(INT2PTR(float128 *, SvIVX(SvRV(a)))), (float128)SvNVX(b));
       return obj_ref;
     }

    if(sv_isobject(b)) {
       const char *h = HvNAME(SvSTASH(SvRV(b)));
       if(strEQ(h, "Math::Float128")) {
        *f = powq(*(INT2PTR(float128 *, SvIVX(SvRV(a)))), *(INT2PTR(float128 *, SvIVX(SvRV(b)))));
        return obj_ref;
      }
      croak("Invalid object supplied to Math::Float128::_overload_pow function");
    }
    croak("Invalid argument supplied to Math::Float128::_overload_pow function");
}

SV * _overload_pow_eq(pTHX_ SV * a, SV * b, SV * third) {

    SvREFCNT_inc(a);

    if(SvUOK(b)) {
       *(INT2PTR(float128 *, SvIVX(SvRV(a)))) = powq(*(INT2PTR(float128 *, SvIVX(SvRV(a)))),
                                                    (float128)SvUVX(b));
        return a;
    }

    if(SvIOK(b)) {
       *(INT2PTR(float128 *, SvIVX(SvRV(a)))) = powq(*(INT2PTR(float128 *, SvIVX(SvRV(a)))),
                                                    (float128)SvIVX(b));
        return a;
    }

    if(SvPOK(b)) {
       char * p;
#ifdef _WIN32_BIZARRE_INFNAN
       int inf_or_nan = _win32_infnanstring(SvPV_nolen(b));
#endif

       NOK_POK_DUALVAR_CHECK , "overload_pow_eq");}

#ifdef _WIN32_BIZARRE_INFNAN

       if(inf_or_nan) {
         if(inf_or_nan == 2) {
           *(INT2PTR(float128 *, SvIVX(SvRV(a)))) = powq(*(INT2PTR(float128 *, SvIVX(SvRV(a)))),
                                                    _get_nan());
           return a;
         }

         *(INT2PTR(float128 *, SvIVX(SvRV(a)))) = powq(*(INT2PTR(float128 *, SvIVX(SvRV(a)))),
                                                    _get_inf(inf_or_nan));
         return a;
       }

       *(INT2PTR(float128 *, SvIVX(SvRV(a)))) = powq(*(INT2PTR(float128 *, SvIVX(SvRV(a)))),
                                                    strtoflt128(SvPV_nolen(b), &p));
       _nnum_inc(p);
       return a;
#else
       *(INT2PTR(float128 *, SvIVX(SvRV(a)))) = powq(*(INT2PTR(float128 *, SvIVX(SvRV(a)))),
                                                    strtoflt128(SvPV_nolen(b), &p));
       _nnum_inc(p);
       return a;
#endif
    }

    if(SvNOK(b)) {
#if defined(AVOID_INF_CAST)
       if(SvNVX(b) != 0.0L && SvNVX(b) == SvNVX(b) && SvNVX(b) / SvNVX(b) != SvNVX(b) / SvNVX(b)) {
         *(INT2PTR(float128 *, SvIVX(SvRV(a)))) = powq(*(INT2PTR(float128 *, SvIVX(SvRV(a)))),
                                                      _get_inf(SvNVX(b) > 0 ? 1 : -1));
          return a;
       }
#endif
       *(INT2PTR(float128 *, SvIVX(SvRV(a)))) = powq(*(INT2PTR(float128 *, SvIVX(SvRV(a)))),
                                                    (float128)SvNVX(b));
        return a;
    }

    if(sv_isobject(b)) {
      const char *h = HvNAME(SvSTASH(SvRV(b)));
      if(strEQ(h, "Math::Float128")) {
        *(INT2PTR(float128 *, SvIVX(SvRV(a)))) = powq(*(INT2PTR(float128 *, SvIVX(SvRV(a)))),
                                                        *(INT2PTR(float128 *, SvIVX(SvRV(b)))));
        return a;
      }
      SvREFCNT_dec(a);
      croak("Invalid object supplied to Math::Float128::_overload_pow_eq function");
    }
    SvREFCNT_dec(a);
    croak("Invalid argument supplied to Math::Float128::_overload_pow_eq function");
}

SV * cmp2NV(pTHX_ SV * flt128_obj, SV * sv) {
     float128 f;
     NV nv;

     if(sv_isobject(flt128_obj)) {
       const char *h = HvNAME(SvSTASH(SvRV(flt128_obj)));
       if(strEQ(h, "Math::Float128")) {
         f = *(INT2PTR(float128 *, SvIVX(SvRV(flt128_obj))));
         nv = SvNV(sv);

         if((f != f) || (nv != nv)) return &PL_sv_undef;
         if(f < (float128)nv) return newSViv(-1);
         if(f > (float128)nv) return newSViv(1);
         return newSViv(0);
       }
       croak("Invalid object supplied to Math::Float128::cmp2NV function");
     }
     croak("Invalid argument supplied to Math::Float128::cmp_NV function");
}

SV * F128toNV(pTHX_ SV * f) {
     return newSVnv((NV)(*(INT2PTR(float128 *, SvIVX(SvRV(f))))));
}

/* #define FLT128_MAX 1.18973149535723176508575932662800702e4932Q */

SV * _FLT128_MAX(pTHX) {
#ifdef FLT128_MAX
     float128 * f;
     SV * obj_ref, * obj;

     Newx(f, 1, float128);
     if(f == NULL) croak("Failed to allocate memory in _FLT128_MAX function");

     obj_ref = newSV(0);
     obj = newSVrv(obj_ref, "Math::Float128");

     *f = FLT128_MAX;

     sv_setiv(obj, INT2PTR(IV,f));
     SvREADONLY_on(obj);
     return obj_ref;
#else
     croak("FLT128_MAX not implemented");
#endif
}

/* #define FLT128_MIN 3.36210314311209350626267781732175260e-4932Q */

SV * _FLT128_MIN(pTHX) {
#ifdef FLT128_MIN
     float128 * f;
     SV * obj_ref, * obj;

     Newx(f, 1, float128);
     if(f == NULL) croak("Failed to allocate memory in _FLT128_MIN function");

     obj_ref = newSV(0);
     obj = newSVrv(obj_ref, "Math::Float128");

     *f = FLT128_MIN;

     sv_setiv(obj, INT2PTR(IV,f));
     SvREADONLY_on(obj);
     return obj_ref;
#else
     croak("FLT128_MIN not implemented");
#endif
}

/* #define FLT128_EPSILON 1.92592994438723585305597794258492732e-34Q */

SV * _FLT128_EPSILON(pTHX) {
#ifdef FLT128_EPSILON
     float128 * f;
     SV * obj_ref, * obj;

     Newx(f, 1, float128);
     if(f == NULL) croak("Failed to allocate memory in _FLT128_EPSILON function");

     obj_ref = newSV(0);
     obj = newSVrv(obj_ref, "Math::Float128");

     *f = FLT128_EPSILON;

     sv_setiv(obj, INT2PTR(IV,f));
     SvREADONLY_on(obj);
     return obj_ref;
#else
     croak("FLT128_EPSILON not implemented");
#endif
}

/* #define FLT128_DENORM_MIN 6.475175119438025110924438958227646552e-4966Q */


SV * _FLT128_DENORM_MIN(pTHX) {
#ifdef FLT128_DENORM_MIN
     float128 * f;
     SV * obj_ref, * obj;

     Newx(f, 1, float128);
     if(f == NULL) croak("Failed to allocate memory in _FLT128_DENORM_MIN function");

     obj_ref = newSV(0);
     obj = newSVrv(obj_ref, "Math::Float128");

     *f = FLT128_DENORM_MIN;

     sv_setiv(obj, INT2PTR(IV,f));
     SvREADONLY_on(obj);
     return obj_ref;
#else
     croak("FLT128_DENORM_MIN not implemented");
#endif
}

/* #define FLT128_MANT_DIG 113 */

int _FLT128_MANT_DIG(void) {
#ifdef FLT128_MANT_DIG
    return (int)FLT128_MANT_DIG;
#else
    croak("FLT128_MANT_DIG not implemented");
#endif
}

/* #define FLT128_MIN_EXP (-16381) */

int _FLT128_MIN_EXP(void) {
#ifdef FLT128_MIN_EXP
    return (int)FLT128_MIN_EXP;
#else
    croak("FLT128_MIN_EXP not implemented");
#endif
}

/* #define FLT128_MAX_EXP 16384 */

int _FLT128_MAX_EXP(void) {
#ifdef FLT128_MAX_EXP
    return (int)FLT128_MAX_EXP;
#else
    croak("FLT128_MAX_EXP not implemented");
#endif
}

/* #define FLT128_MIN_10_EXP (-4931) */

int _FLT128_MIN_10_EXP(void) {
#ifdef FLT128_MIN_10_EXP
    return (int)FLT128_MIN_10_EXP;
#else
    croak("FLT128_MIN_10_EXP not implemented");
#endif
}

/* #define FLT128_MAX_10_EXP 4932 */

int _FLT128_MAX_10_EXP(void) {
#ifdef FLT128_MAX_10_EXP
    return (int)FLT128_MAX_10_EXP;
#else
    croak("FLT128_MAX_10_EXP not implemented");
#endif
}

/* #define HUGE_VALQ __builtin_huge_valq() */


/*#define M_Eq		2.7182818284590452353602874713526625Q */  /* e */

SV * _M_Eq(pTHX) {
#ifndef M_Eq
#define M_Eq expq(1.0Q)
#endif
     float128 * f;
     SV * obj_ref, * obj;

     Newx(f, 1, float128);
     if(f == NULL) croak("Failed to allocate memory in _M_Eq function");

     obj_ref = newSV(0);
     obj = newSVrv(obj_ref, "Math::Float128");

     *f = M_Eq;

     sv_setiv(obj, INT2PTR(IV,f));
     SvREADONLY_on(obj);
     return obj_ref;
}

/* #define M_LOG2Eq	1.4426950408889634073599246810018921Q */  /* log_2 e */

SV * _M_LOG2Eq(pTHX) {
#ifndef M_LOG2Eq
#define M_LOG2Eq log2q(expq(1.0Q))
#endif
     float128 * f;
     SV * obj_ref, * obj;

     Newx(f, 1, float128);
     if(f == NULL) croak("Failed to allocate memory in _M_LOG2Eq function");

     obj_ref = newSV(0);
     obj = newSVrv(obj_ref, "Math::Float128");

     *f = M_LOG2Eq;

     sv_setiv(obj, INT2PTR(IV,f));
     SvREADONLY_on(obj);
     return obj_ref;
}

/* #define M_LOG10Eq	0.4342944819032518276511289189166051Q */  /* log_10 e */

SV * _M_LOG10Eq(pTHX) {
#ifndef M_LOG10Eq
#define M_LOG10Eq lo10q(expq(1.0Q))
#endif
     float128 * f;
     SV * obj_ref, * obj;

     Newx(f, 1, float128);
     if(f == NULL) croak("Failed to allocate memory in _M_LOG10Eq function");

     obj_ref = newSV(0);
     obj = newSVrv(obj_ref, "Math::Float128");

     *f = M_LOG10Eq;

     sv_setiv(obj, INT2PTR(IV,f));
     SvREADONLY_on(obj);
     return obj_ref;
}

/* #define M_LN2q		0.6931471805599453094172321214581766Q */  /* log_e 2 */

SV * _M_LN2q(pTHX) {
#ifndef M_LN2q
#define M_LN2q logq(2.0Q)
#endif
     float128 * f;
     SV * obj_ref, * obj;

     Newx(f, 1, float128);
     if(f == NULL) croak("Failed to allocate memory in _M_LN2q function");

     obj_ref = newSV(0);
     obj = newSVrv(obj_ref, "Math::Float128");

     *f = M_LN2q;

     sv_setiv(obj, INT2PTR(IV,f));
     SvREADONLY_on(obj);
     return obj_ref;
}

/* #define M_LN10q		2.3025850929940456840179914546843642Q */ /* log_e 10 */

SV * _M_LN10q(pTHX) {
#ifndef M_LN10q
#define M_LN10q logq(10.0Q)
#endif
     float128 * f;
     SV * obj_ref, * obj;

     Newx(f, 1, float128);
     if(f == NULL) croak("Failed to allocate memory in _M_LN10q function");

     obj_ref = newSV(0);
     obj = newSVrv(obj_ref, "Math::Float128");

     *f = M_LN10q;

     sv_setiv(obj, INT2PTR(IV,f));
     SvREADONLY_on(obj);
     return obj_ref;
}

/* #define M_PIq		3.1415926535897932384626433832795029Q */  /* pi */

SV * _M_PIq(pTHX) {
#ifndef M_PIq
#define M_PIq 2.0Q*asinq(1.0Q)
#endif
     float128 * f;
     SV * obj_ref, * obj;

     Newx(f, 1, float128);
     if(f == NULL) croak("Failed to allocate memory in _M_PIq function");

     obj_ref = newSV(0);
     obj = newSVrv(obj_ref, "Math::Float128");

     *f = M_PIq;

     sv_setiv(obj, INT2PTR(IV,f));
     SvREADONLY_on(obj);
     return obj_ref;
}

/* #define M_PI_2q		1.5707963267948966192313216916397514Q */  /* pi/2 */

SV * _M_PI_2q(pTHX) {
#ifndef M_PI_2q
#define M_PI_2q asinq(1.0Q)
#endif
     float128 * f;
     SV * obj_ref, * obj;

     Newx(f, 1, float128);
     if(f == NULL) croak("Failed to allocate memory in _M_PI_2q function");

     obj_ref = newSV(0);
     obj = newSVrv(obj_ref, "Math::Float128");

     *f = M_PI_2q;

     sv_setiv(obj, INT2PTR(IV,f));
     SvREADONLY_on(obj);
     return obj_ref;
}

/* #define M_PI_4q		0.7853981633974483096156608458198757Q */  /* pi/4 */

SV * _M_PI_4q(pTHX) {
#ifndef M_PI_4q
#define M_PI_4q asinq(1.0Q)/2.0Q
#endif
     float128 * f;
     SV * obj_ref, * obj;

     Newx(f, 1, float128);
     if(f == NULL) croak("Failed to allocate memory in _M_PI_4q function");

     obj_ref = newSV(0);
     obj = newSVrv(obj_ref, "Math::Float128");

     *f = M_PI_4q;

     sv_setiv(obj, INT2PTR(IV,f));
     SvREADONLY_on(obj);
     return obj_ref;
}

/* #define M_1_PIq		0.3183098861837906715377675267450287Q */  /* 1/pi */

SV * _M_1_PIq(pTHX) {
#ifndef M_1_PIq
#define M_1_PIq 0.5Q/asinq(1.0Q)
#endif
     float128 * f;
     SV * obj_ref, * obj;

     Newx(f, 1, float128);
     if(f == NULL) croak("Failed to allocate memory in _M_1_PIq function");

     obj_ref = newSV(0);
     obj = newSVrv(obj_ref, "Math::Float128");

     *f = M_1_PIq;

     sv_setiv(obj, INT2PTR(IV,f));
     SvREADONLY_on(obj);
     return obj_ref;
}

/* #define M_2_PIq		0.6366197723675813430755350534900574Q */  /* 2/pi */

SV * _M_2_PIq(pTHX) {
#ifndef M_2_PIq
#define M_2_PIq 1.0Q/asinq(1.0Q)
#endif
     float128 * f;
     SV * obj_ref, * obj;

     Newx(f, 1, float128);
     if(f == NULL) croak("Failed to allocate memory in _M_2_PIq function");

     obj_ref = newSV(0);
     obj = newSVrv(obj_ref, "Math::Float128");

     *f = M_2_PIq;

     sv_setiv(obj, INT2PTR(IV,f));
     SvREADONLY_on(obj);
     return obj_ref;
}

/* #define M_2_SQRTPIq	1.1283791670955125738961589031215452Q */  /* 2/sqrt(pi) */

SV * _M_2_SQRTPIq(pTHX) {
#ifndef M_2_SQRTPIq
#define M_2_SQRTPIq 2.0Q/sqrtq(2.0Q*asinq(1.0Q))
#endif
     float128 * f;
     SV * obj_ref, * obj;

     Newx(f, 1, float128);
     if(f == NULL) croak("Failed to allocate memory in _M_2_SQRTPIq function");

     obj_ref = newSV(0);
     obj = newSVrv(obj_ref, "Math::Float128");

     *f = M_2_SQRTPIq;

     sv_setiv(obj, INT2PTR(IV,f));
     SvREADONLY_on(obj);
     return obj_ref;
}

/* #define M_SQRT2q	1.4142135623730950488016887242096981Q */  /* sqrt(2) */

SV * _M_SQRT2q(pTHX) {
#ifndef M_SQRT2q
#define M_SQRT2q sqrtq(2.0Q)
#endif
     float128 * f;
     SV * obj_ref, * obj;

     Newx(f, 1, float128);
     if(f == NULL) croak("Failed to allocate memory in _M_SQRT2q function");

     obj_ref = newSV(0);
     obj = newSVrv(obj_ref, "Math::Float128");

     *f = M_SQRT2q;

     sv_setiv(obj, INT2PTR(IV,f));
     SvREADONLY_on(obj);
     return obj_ref;
}

/* #define M_SQRT1_2q	0.7071067811865475244008443621048490Q */  /* 1/sqrt(2) */

SV * _M_SQRT1_2q(pTHX) {
#ifndef M_SQRT1_2q
#define M_SQRT1_2q 1.0Q/sqrtq(2.0Q)
#endif
     float128 * f;
     SV * obj_ref, * obj;

     Newx(f, 1, float128);
     if(f == NULL) croak("Failed to allocate memory in _M_SQRT1_2q function");

     obj_ref = newSV(0);
     obj = newSVrv(obj_ref, "Math::Float128");

     *f = M_SQRT1_2q;

     sv_setiv(obj, INT2PTR(IV,f));
     SvREADONLY_on(obj);
     return obj_ref;
}

void _f128_bytes(pTHX_ SV * sv) {
  dXSARGS;
  float128 f128 = *(INT2PTR(float128 *, SvIVX(SvRV(sv))));
  int i, n = sizeof(float128);
  char * buff;
  void * p = &f128;

  Newx(buff, 4, char);
  if(buff == NULL) croak("Failed to allocate memory in _f128_bytes function");

  sp = mark;

#ifdef WE_HAVE_BENDIAN /* Big Endian architecture */
  for (i = 0; i < n; i++) {
#else
  for (i = n - 1; i >= 0; i--) {
#endif

    sprintf(buff, "%02X", ((unsigned char*)p)[i]);
    XPUSHs(sv_2mortal(newSVpv(buff, 0)));
  }
  PUTBACK;
  Safefree(buff);
  XSRETURN(n);
}

void acos_F128(float128 * rop, float128 * op) {
  *rop = acosq(*op);
}

void acosh_F128(float128 * rop, float128 * op) {
  *rop = acoshq(*op);
}

void asin_F128(float128 * rop, float128 * op) {
  *rop = asinq(*op);
}

void asinh_F128(float128 * rop, float128 * op) {
  *rop = asinhq(*op);
}

void atan_F128(float128 * rop, float128 * op) {
  *rop = atanq(*op);
}

void atanh_F128(float128 * rop, float128 * op) {
  *rop = atanhq(*op);
}

void atan2_F128(float128 * rop, float128 * op1, float128 * op2) {
  *rop = atan2q(*op1, *op2);
}

void cbrt_F128(float128 * rop, float128 * op) {
  *rop = cbrtq(*op);
}

void ceil_F128(float128 * rop, float128 * op) {
  *rop = ceilq(*op);
}

void copysign_F128(float128 * rop, float128 * op1, float128 * op2) {
  *rop = copysignq(*op1, *op2);
}

void cosh_F128(float128 * rop, float128 * op) {
#if defined(__MINGW64_VERSION_MAJOR) && __MINGW64_VERSION_MAJOR < 4 /* avoid calling coshq() as it's buggy */
  float128 temp = sinhq(*op);
  temp = powq(temp, 2) + 1.0Q;
  *rop = sqrtq(temp);
#else
  *rop = coshq(*op);
#endif
}

void cos_F128(float128 * rop, float128 * op) {
  *rop = cosq(*op);
}

void erf_F128(float128 * rop, float128 * op) {
  *rop = erfq(*op);
}

void erfc_F128(float128 * rop, float128 * op) {
  *rop = erfcq(*op);
}

void exp_F128(float128 * rop, float128 * op) {
#if defined(__MINGW64_VERSION_MAJOR) && __MINGW64_VERSION_MAJOR < 4 /* avoid calling expq() as it's buggy */
  *rop = powq(M_Eq, *op);
#else
  *rop = expq(*op);
#endif
}

void expm1_F128(float128 * rop, float128 * op) {
  *rop = expm1q(*op);
}

void fabs_F128(float128 * rop, float128 * op) {
  *rop = fabsq(*op);
}

void fdim_F128(float128 * rop, float128 * op1, float128 * op2) {
  *rop = fdimq(*op1, *op2);
}

int finite_F128(float128 * op) {
  return finiteq(*op);
}

void floor_F128(float128 * rop, float128 * op) {
  *rop = floorq(*op);
}

void fma_F128(float128 * rop, float128 * op1, float128 * op2, float128 * op3) {
#if defined(__MINGW64_VERSION_MAJOR) && __MINGW64_VERSION_MAJOR < 4 /* avoid calling fmaq() as it's buggy */
  float128 temp = *op1 * *op2;
  temp += *op3;
  *rop = temp;
#else
  *rop = fmaq(*op1, *op2, *op3);
#endif
}

void fmax_F128(float128 * rop, float128 * op1, float128 * op2) {
  *rop = fmaxq(*op1, *op2);
}

void fmin_F128(float128 * rop, float128 * op1, float128 * op2) {
  *rop = fminq(*op1, *op2);
}

void fmod_F128(float128 * rop, float128 * op1, float128 * op2) {
  *rop = fmodq(*op1, *op2);
}

void hypot_F128(float128 * rop, float128 * op1, float128 * op2) {
  *rop = hypotq(*op1, *op2);
}

void frexp_F128(pTHX_ float128 * frac, SV * exp, float128 * op) {
  int e;
  *frac = frexpq(*op, &e);
  sv_setsv(exp, newSViv(e));
}

void ldexp_F128(float128 * rop, float128 * op, int pow) {
  *rop = ldexpq(*op, pow);
}

int isinf_F128(float128 * op) {
  return isinfq(*op);
}

int ilogb_F128(float128 * op) {
  return ilogbq(*op);
}

int isnan_F128(float128 * op) {
  return isnanq(*op);
}

void j0_F128(float128 * rop, float128 * op) {
  *rop = j0q(*op);
}

void j1_F128(float128 * rop, float128 * op) {
  *rop = j1q(*op);
}

void jn_F128(float128 * rop, int n, float128 * op) {
  *rop = jnq(n, *op);
}

void lgamma_F128(float128 * rop, float128 * op) {
  *rop = lgammaq(*op);
}

SV * llrint_F128(pTHX_ float128 * op) {
#ifdef LONGLONG2IV_IS_OK
  return newSViv((IV)llrintq(*op));
#else
  warn("llrint_F128 not implemented: IV size (%d) is smaller than longlong size (%d)\n", sizeof(IV), sizeof(long long int));
  croak("Use lrint_F128 instead");
#endif
}

SV * llround_F128(pTHX_ float128 * op) {
#ifdef LONGLONG2IV_IS_OK
  return newSViv((IV)llroundq(*op));
#else
  warn("llround_F128 not implemented: IV size (%d) is smaller than longlong size (%d)\n", sizeof(IV), sizeof(long long int));
  croak("Use lround_F128 instead");
#endif
}

SV * lrint_F128(pTHX_ float128 * op) {
#ifdef LONG2IV_IS_OK
  return newSViv((IV)lrintq(*op));
#else
  croak("lrint_F128 not implemented: IV size (%d) is smaller than long size (%d)", sizeof(IV), sizeof(long));
#endif
}

SV * lround_F128(pTHX_ float128 * op) {
#ifdef LONG2IV_IS_OK
  return newSViv((IV)lroundq(*op));
#else
  croak("lround_F128 not implemented: IV size (%d) is smaller than long size (%d)", sizeof(IV), sizeof(long));
#endif
}

void log_F128(float128 * rop, float128 * op) {
  *rop = logq(*op);
}

void log10_F128(float128 * rop, float128 * op) {
  *rop = log10q(*op);
}

void log2_F128(float128 * rop, float128 * op) {
  *rop = log2q(*op);
}

void log1p_F128(float128 * rop, float128 * op) {
  *rop = log1pq(*op);
}

void modf_F128(float128 * integer, float128 * frac, float128 * op) {
  float128 ret;
  *frac = modfq(*op, &ret);
  *integer = ret;
}

void nan_F128(pTHX_ float128 * rop, SV * op) {
  *rop = nanq(SvPV_nolen(op));
}

void nearbyint_F128(float128 * rop, float128 * op) {
#if defined(__MINGW64_VERSION_MAJOR) && __MINGW64_VERSION_MAJOR < 4 /* avoid calling nearbyintq() as it's buggy */
  float128 do_floor, do_ceil;
  int rnd = fegetround();
  if(*op == 0.0Q || isinfq(*op) || isnanq(*op)) {
    *rop = *op;
    return;
  }
  do_floor = *op - floorq(*op);
  do_ceil  = ceilq(*op) - *op;
  if(do_ceil < do_floor) {
    *rop = ceilq(*op);
    return;
  }
  if(do_ceil > do_floor) {
    *rop = floorq(*op);
    return;
  }
  if(do_floor == do_ceil) {
    if(rnd == FE_TONEAREST) {
      if(remainderq(floorq(*op), 2.0Q) == 0.0Q) *rop = floorq(*op);
      else *rop = ceilq(*op);
      return;
    }
    if(rnd == FE_UPWARD) {
      *rop = ceilq(*op);
      return;
    }
    if(rnd == FE_DOWNWARD) {
      *rop = floorq(*op);
      return;
    }
    if(rnd == FE_TOWARDZERO) {
      if(*op < 0.0Q) *rop = ceilq(*op);
      if(*op > 0.0Q) *rop = floorq(*op);
      return;
    }
  croak("nearbyint_F128 workaround for mingw64 compiler failed\n");
  }
#else
  *rop = nearbyintq(*op);
#endif
}

void nextafter_F128(float128 * rop, float128 * op1, float128 * op2) {
  *rop = nextafterq(*op1, *op2);
}

void pow_F128(float128 * rop, float128 * op1, float128 * op2) {
  *rop = powq(*op1, *op2);
}

void remainder_F128(float128 * rop, float128 * op1, float128 * op2) {
  *rop = remainderq(*op1, *op2);
}

void remquo_F128(pTHX_ float128 * rop1, SV * rop2, float128 * op1, float128 * op2) {
  int ret;
  *rop1 = remquoq(*op1, *op2, &ret);
  sv_setsv(rop2, newSViv(ret));
}

void rint_F128(float128 * rop, float128 * op) {
  *rop = rintq(*op);
}

void round_F128(float128 * rop, float128 * op) {
  *rop = roundq(*op);
}

void scalbln_F128(float128 * rop, float128 * op1, long op2) {
  *rop = scalblnq(*op1, op2);
}

void scalbn_F128(float128 * rop, float128 * op1, int op2) {
  *rop = scalbnq(*op1, op2);
}

int signbit_F128(float128 * op) {
  return signbitq(*op);
}

void sincos_F128(float128 * sin, float128 * cos, float128 * op) {
  float128 sine, cosine;
  sincosq(*op, &sine, &cosine);
  *sin = sine;
  *cos = cosine;
}

void sinh_F128(float128 * rop, float128 * op) {
  *rop = sinhq(*op);
}

void sin_F128(float128 * rop, float128 * op) {
  *rop = sinq(*op);
}

void sqrt_F128(float128 * rop, float128 * op) {
  *rop = sqrtq(*op);
}

void tan_F128(float128 * rop, float128 * op) {
  *rop = tanq(*op);
}

void tanh_F128(float128 * rop, float128 * op) {
  *rop = tanhq(*op);
}

void tgamma_F128(float128 * rop, float128 * op) {
#if defined(__MINGW64_VERSION_MAJOR) && __MINGW64_VERSION_MAJOR < 4 /* avoid calling tgammaq() as it's buggy */
  *rop = powq(M_Eq, lgammaq(*op));
#else
  *rop = tgammaq(*op);
#endif
}

void trunc_F128(float128 * rop, float128 * op) {
  *rop = truncq(*op);
}

void y0_F128(float128 * rop, float128 * op) {
  *rop = y0q(*op);
}

void y1_F128(float128 * rop, float128 * op) {
  *rop = y1q(*op);
}

void yn_F128(float128 * rop, int n, float128 * op) {
  *rop = ynq(n, *op);
}

int _longlong2iv_is_ok(void) {

/* Is longlong to IV conversion guaranteed to not lose precision ? */
#ifdef LONGLONG2IV_IS_OK
  return 1;
#else
  return 0;
#endif

}

/* Is long to IV conversion guaranteed to not lose precision ? */
int _long2iv_is_ok(void) {

#ifdef LONG2IV_IS_OK
  return 1;
#else
  return 0;
#endif

}

/* FLT_RADIX is probably 2, but we can use this if we need to be sure. */
int _flt_radix(void) {
#ifdef FLT_RADIX
  return (int)FLT_RADIX;
#else
  return 0;
#endif
}

SV * _fegetround(pTHX) {
#ifdef __MINGW64_VERSION_MAJOR /* fenv.h has been included */
  int r = fegetround();
  if(r == FE_TONEAREST) return newSVpv("FE_TONEAREST", 0);
  if(r == FE_TOWARDZERO) return newSVpv("FE_TOWARDZERO", 0);
  if(r == FE_UPWARD) return newSVpv("FE_UPWARD", 0);
  if(r == FE_DOWNWARD) return newSVpv("FE_DOWNWARD", 0);
  return newSVpv("Unknown rounding mode", 0);
#else
  return newSVpv("Rounding mode undetermined - fenv.h not loaded", 0);
#endif
}

int nnumflag(void) {
  return nnum;
}

void clear_nnum(void) {
  nnum = 0;
}

void set_nnum(int x) {
  nnum = x;
}

int _lln(pTHX_ SV * x) {
  if(looks_like_number(x)) return 1;
  return 0;
}

int nok_pokflag(void) {
  return nok_pok;
}

void clear_nok_pok(void){
  nok_pok = 0;
}

void set_nok_pok(int x) {
  nok_pok = x;
}

int _SvNOK(pTHX_ SV * in) {
  if(SvNOK(in)) return 1;
  return 0;
}

int _SvPOK(pTHX_ SV * in) {
  if(SvPOK(in)) return 1;
  return 0;
}

int _avoid_inf_cast(void) {
#if defined(AVOID_INF_CAST)
  return 1;
#else
  return 0;
#endif
}


#line 3084 "Float128.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
	    Perl_croak_nocontext("Usage: %s::%s(%s)", hvname, gvname, params);
        else
	    Perl_croak_nocontext("Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
	Perl_croak_nocontext("Usage: CODE(0x%" UVxf ")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#define croak_xs_usage        S_croak_xs_usage

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#if PERL_VERSION_LE(5, 21, 5)
#  define newXS_deffile(a,b) Perl_newXS(aTHX_ a,b,file)
#else
#  define newXS_deffile(a,b) Perl_newXS_deffile(aTHX_ a,b)
#endif

#line 3228 "Float128.c"

XS_EUPXS(XS_Math__Float128_NOK_POK_val); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Float128_NOK_POK_val)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	int	RETVAL;
	dXSTARG;
#line 3082 "Float128.xs"
  RETVAL = NOK_POK_val (aTHX);
#line 3241 "Float128.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Float128__win32_infnanstring); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Float128__win32_infnanstring)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "s");
    {
	char *	s = (char *)SvPV_nolen(ST(0))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = _win32_infnanstring(s);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Float128_flt128_set_prec); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Float128_flt128_set_prec)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "x");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	int	x = (int)SvIV(ST(0))
;
#line 3094 "Float128.xs"
        I32* temp;
#line 3280 "Float128.c"
#line 3096 "Float128.xs"
        temp = PL_markstack_ptr++;
        flt128_set_prec(aTHX_ x);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 3291 "Float128.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__Float128_flt128_get_prec); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Float128_flt128_get_prec)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	int	RETVAL;
	dXSTARG;

	RETVAL = flt128_get_prec();
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Float128_InfF128); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Float128_InfF128)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "sign");
    {
	int	sign = (int)SvIV(ST(0))
;
	SV *	RETVAL;
#line 3114 "Float128.xs"
  RETVAL = InfF128 (aTHX_ sign);
#line 3327 "Float128.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Float128_NaNF128); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Float128_NaNF128)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	SV *	RETVAL;
#line 3120 "Float128.xs"
  RETVAL = NaNF128 (aTHX);
#line 3345 "Float128.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Float128_ZeroF128); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Float128_ZeroF128)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "sign");
    {
	int	sign = (int)SvIV(ST(0))
;
	SV *	RETVAL;
#line 3128 "Float128.xs"
  RETVAL = ZeroF128 (aTHX_ sign);
#line 3365 "Float128.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Float128_UnityF128); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Float128_UnityF128)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "sign");
    {
	int	sign = (int)SvIV(ST(0))
;
	SV *	RETVAL;
#line 3135 "Float128.xs"
  RETVAL = UnityF128 (aTHX_ sign);
#line 3385 "Float128.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Float128_is_NaNF128); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Float128_is_NaNF128)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "b");
    {
	SV *	b = ST(0)
;
	SV *	RETVAL;
#line 3142 "Float128.xs"
  RETVAL = is_NaNF128 (aTHX_ b);
#line 3405 "Float128.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Float128_is_InfF128); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Float128_is_InfF128)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "b");
    {
	SV *	b = ST(0)
;
	SV *	RETVAL;
#line 3149 "Float128.xs"
  RETVAL = is_InfF128 (aTHX_ b);
#line 3425 "Float128.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Float128_is_ZeroF128); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Float128_is_ZeroF128)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "b");
    {
	SV *	b = ST(0)
;
	SV *	RETVAL;
#line 3156 "Float128.xs"
  RETVAL = is_ZeroF128 (aTHX_ b);
#line 3445 "Float128.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Float128__nnum_inc); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Float128__nnum_inc)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "p");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	char *	p = (char *)SvPV_nolen(ST(0))
;
#line 3163 "Float128.xs"
        I32* temp;
#line 3466 "Float128.c"
#line 3165 "Float128.xs"
        temp = PL_markstack_ptr++;
        _nnum_inc(p);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 3477 "Float128.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__Float128_STRtoF128); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Float128_STRtoF128)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "str");
    {
	SV *	str = ST(0)
;
	SV *	RETVAL;
#line 3179 "Float128.xs"
  RETVAL = STRtoF128 (aTHX_ str);
#line 3496 "Float128.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Float128_fromSTR); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Float128_fromSTR)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "f, str");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	float128 *            f = INT2PTR(float128 *, SvIVX(SvRV(ST(0))))
;
	SV *	str = ST(1)
;
#line 3187 "Float128.xs"
        I32* temp;
#line 3519 "Float128.c"
#line 3189 "Float128.xs"
        temp = PL_markstack_ptr++;
        fromSTR(aTHX_ f, str);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 3530 "Float128.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__Float128_NVtoF128); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Float128_NVtoF128)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "nv");
    {
	SV *	nv = ST(0)
;
	SV *	RETVAL;
#line 3203 "Float128.xs"
  RETVAL = NVtoF128 (aTHX_ nv);
#line 3549 "Float128.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Float128_fromNV); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Float128_fromNV)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "f, nv");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	float128 *            f = INT2PTR(float128 *, SvIVX(SvRV(ST(0))))
;
	SV *	nv = ST(1)
;
#line 3211 "Float128.xs"
        I32* temp;
#line 3572 "Float128.c"
#line 3213 "Float128.xs"
        temp = PL_markstack_ptr++;
        fromNV(aTHX_ f, nv);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 3583 "Float128.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__Float128_IVtoF128); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Float128_IVtoF128)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "iv");
    {
	SV *	iv = ST(0)
;
	SV *	RETVAL;
#line 3227 "Float128.xs"
  RETVAL = IVtoF128 (aTHX_ iv);
#line 3602 "Float128.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Float128_fromIV); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Float128_fromIV)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "f, iv");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	float128 *            f = INT2PTR(float128 *, SvIVX(SvRV(ST(0))))
;
	SV *	iv = ST(1)
;
#line 3235 "Float128.xs"
        I32* temp;
#line 3625 "Float128.c"
#line 3237 "Float128.xs"
        temp = PL_markstack_ptr++;
        fromIV(aTHX_ f, iv);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 3636 "Float128.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__Float128_UVtoF128); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Float128_UVtoF128)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "uv");
    {
	SV *	uv = ST(0)
;
	SV *	RETVAL;
#line 3251 "Float128.xs"
  RETVAL = UVtoF128 (aTHX_ uv);
#line 3655 "Float128.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Float128_fromUV); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Float128_fromUV)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "f, uv");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	float128 *            f = INT2PTR(float128 *, SvIVX(SvRV(ST(0))))
;
	SV *	uv = ST(1)
;
#line 3259 "Float128.xs"
        I32* temp;
#line 3678 "Float128.c"
#line 3261 "Float128.xs"
        temp = PL_markstack_ptr++;
        fromUV(aTHX_ f, uv);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 3689 "Float128.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__Float128_F128toSTR); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Float128_F128toSTR)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "f");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	f = ST(0)
;
#line 3275 "Float128.xs"
        I32* temp;
#line 3709 "Float128.c"
#line 3277 "Float128.xs"
        temp = PL_markstack_ptr++;
        F128toSTR(aTHX_ f);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 3720 "Float128.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__Float128_F128toSTRP); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Float128_F128toSTRP)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "f, decimal_prec");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	f = ST(0)
;
	int	decimal_prec = (int)SvIV(ST(1))
;
#line 3292 "Float128.xs"
        I32* temp;
#line 3742 "Float128.c"
#line 3294 "Float128.xs"
        temp = PL_markstack_ptr++;
        F128toSTRP(aTHX_ f, decimal_prec);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 3753 "Float128.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__Float128_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Float128_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "f");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	f = ST(0)
;
#line 3308 "Float128.xs"
        I32* temp;
#line 3773 "Float128.c"
#line 3310 "Float128.xs"
        temp = PL_markstack_ptr++;
        DESTROY(aTHX_ f);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 3784 "Float128.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__Float128__LDBL_DIG); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Float128__LDBL_DIG)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	SV *	RETVAL;
#line 3323 "Float128.xs"
  RETVAL = _LDBL_DIG (aTHX);
#line 3801 "Float128.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Float128__DBL_DIG); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Float128__DBL_DIG)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	SV *	RETVAL;
#line 3330 "Float128.xs"
  RETVAL = _DBL_DIG (aTHX);
#line 3819 "Float128.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Float128__FLT128_DIG); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Float128__FLT128_DIG)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	SV *	RETVAL;
#line 3337 "Float128.xs"
  RETVAL = _FLT128_DIG (aTHX);
#line 3837 "Float128.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Float128__overload_add); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Float128__overload_add)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, third");
    {
	SV *	a = ST(0)
;
	SV *	b = ST(1)
;
	SV *	third = ST(2)
;
	SV *	RETVAL;
#line 3347 "Float128.xs"
  RETVAL = _overload_add (aTHX_ a, b, third);
#line 3861 "Float128.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Float128__overload_mul); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Float128__overload_mul)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, third");
    {
	SV *	a = ST(0)
;
	SV *	b = ST(1)
;
	SV *	third = ST(2)
;
	SV *	RETVAL;
#line 3356 "Float128.xs"
  RETVAL = _overload_mul (aTHX_ a, b, third);
#line 3885 "Float128.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Float128__overload_sub); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Float128__overload_sub)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, third");
    {
	SV *	a = ST(0)
;
	SV *	b = ST(1)
;
	SV *	third = ST(2)
;
	SV *	RETVAL;
#line 3365 "Float128.xs"
  RETVAL = _overload_sub (aTHX_ a, b, third);
#line 3909 "Float128.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Float128__overload_div); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Float128__overload_div)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, third");
    {
	SV *	a = ST(0)
;
	SV *	b = ST(1)
;
	SV *	third = ST(2)
;
	SV *	RETVAL;
#line 3374 "Float128.xs"
  RETVAL = _overload_div (aTHX_ a, b, third);
#line 3933 "Float128.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Float128__overload_equiv); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Float128__overload_equiv)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, third");
    {
	SV *	a = ST(0)
;
	SV *	b = ST(1)
;
	SV *	third = ST(2)
;
	SV *	RETVAL;
#line 3383 "Float128.xs"
  RETVAL = _overload_equiv (aTHX_ a, b, third);
#line 3957 "Float128.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Float128__overload_not_equiv); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Float128__overload_not_equiv)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, third");
    {
	SV *	a = ST(0)
;
	SV *	b = ST(1)
;
	SV *	third = ST(2)
;
	SV *	RETVAL;
#line 3392 "Float128.xs"
  RETVAL = _overload_not_equiv (aTHX_ a, b, third);
#line 3981 "Float128.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Float128__overload_true); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Float128__overload_true)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, third");
    {
	SV *	a = ST(0)
;
	SV *	b = ST(1)
;
	SV *	third = ST(2)
;
	SV *	RETVAL;
#line 3401 "Float128.xs"
  RETVAL = _overload_true (aTHX_ a, b, third);
#line 4005 "Float128.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Float128__overload_not); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Float128__overload_not)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, third");
    {
	SV *	a = ST(0)
;
	SV *	b = ST(1)
;
	SV *	third = ST(2)
;
	SV *	RETVAL;
#line 3410 "Float128.xs"
  RETVAL = _overload_not (aTHX_ a, b, third);
#line 4029 "Float128.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Float128__overload_add_eq); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Float128__overload_add_eq)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, third");
    {
	SV *	a = ST(0)
;
	SV *	b = ST(1)
;
	SV *	third = ST(2)
;
	SV *	RETVAL;
#line 3419 "Float128.xs"
  RETVAL = _overload_add_eq (aTHX_ a, b, third);
#line 4053 "Float128.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Float128__overload_mul_eq); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Float128__overload_mul_eq)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, third");
    {
	SV *	a = ST(0)
;
	SV *	b = ST(1)
;
	SV *	third = ST(2)
;
	SV *	RETVAL;
#line 3428 "Float128.xs"
  RETVAL = _overload_mul_eq (aTHX_ a, b, third);
#line 4077 "Float128.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Float128__overload_sub_eq); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Float128__overload_sub_eq)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, third");
    {
	SV *	a = ST(0)
;
	SV *	b = ST(1)
;
	SV *	third = ST(2)
;
	SV *	RETVAL;
#line 3437 "Float128.xs"
  RETVAL = _overload_sub_eq (aTHX_ a, b, third);
#line 4101 "Float128.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Float128__overload_div_eq); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Float128__overload_div_eq)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, third");
    {
	SV *	a = ST(0)
;
	SV *	b = ST(1)
;
	SV *	third = ST(2)
;
	SV *	RETVAL;
#line 3446 "Float128.xs"
  RETVAL = _overload_div_eq (aTHX_ a, b, third);
#line 4125 "Float128.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Float128__overload_lt); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Float128__overload_lt)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, third");
    {
	SV *	a = ST(0)
;
	SV *	b = ST(1)
;
	SV *	third = ST(2)
;
	SV *	RETVAL;
#line 3455 "Float128.xs"
  RETVAL = _overload_lt (aTHX_ a, b, third);
#line 4149 "Float128.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Float128__overload_gt); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Float128__overload_gt)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, third");
    {
	SV *	a = ST(0)
;
	SV *	b = ST(1)
;
	SV *	third = ST(2)
;
	SV *	RETVAL;
#line 3464 "Float128.xs"
  RETVAL = _overload_gt (aTHX_ a, b, third);
#line 4173 "Float128.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Float128__overload_lte); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Float128__overload_lte)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, third");
    {
	SV *	a = ST(0)
;
	SV *	b = ST(1)
;
	SV *	third = ST(2)
;
	SV *	RETVAL;
#line 3473 "Float128.xs"
  RETVAL = _overload_lte (aTHX_ a, b, third);
#line 4197 "Float128.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Float128__overload_gte); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Float128__overload_gte)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, third");
    {
	SV *	a = ST(0)
;
	SV *	b = ST(1)
;
	SV *	third = ST(2)
;
	SV *	RETVAL;
#line 3482 "Float128.xs"
  RETVAL = _overload_gte (aTHX_ a, b, third);
#line 4221 "Float128.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Float128__overload_spaceship); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Float128__overload_spaceship)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, third");
    {
	SV *	a = ST(0)
;
	SV *	b = ST(1)
;
	SV *	third = ST(2)
;
	SV *	RETVAL;
#line 3491 "Float128.xs"
  RETVAL = _overload_spaceship (aTHX_ a, b, third);
#line 4245 "Float128.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Float128__overload_copy); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Float128__overload_copy)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, third");
    {
	SV *	a = ST(0)
;
	SV *	b = ST(1)
;
	SV *	third = ST(2)
;
	SV *	RETVAL;
#line 3500 "Float128.xs"
  RETVAL = _overload_copy (aTHX_ a, b, third);
#line 4269 "Float128.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Float128_F128toF128); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Float128_F128toF128)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "a");
    {
	SV *	a = ST(0)
;
	SV *	RETVAL;
#line 3507 "Float128.xs"
  RETVAL = F128toF128 (aTHX_ a);
#line 4289 "Float128.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Float128_fromF128); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Float128_fromF128)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "f, a");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	float128 *            f = INT2PTR(float128 *, SvIVX(SvRV(ST(0))))
;
	SV *	a = ST(1)
;
#line 3515 "Float128.xs"
        I32* temp;
#line 4312 "Float128.c"
#line 3517 "Float128.xs"
        temp = PL_markstack_ptr++;
        fromF128(aTHX_ f, a);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 4323 "Float128.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__Float128__itsa); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Float128__itsa)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "a");
    {
	SV *	a = ST(0)
;
	SV *	RETVAL;
#line 3531 "Float128.xs"
  RETVAL = _itsa (aTHX_ a);
#line 4342 "Float128.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Float128__overload_abs); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Float128__overload_abs)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, third");
    {
	SV *	a = ST(0)
;
	SV *	b = ST(1)
;
	SV *	third = ST(2)
;
	SV *	RETVAL;
#line 3540 "Float128.xs"
  RETVAL = _overload_abs (aTHX_ a, b, third);
#line 4366 "Float128.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Float128__overload_int); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Float128__overload_int)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, third");
    {
	SV *	a = ST(0)
;
	SV *	b = ST(1)
;
	SV *	third = ST(2)
;
	SV *	RETVAL;
#line 3549 "Float128.xs"
  RETVAL = _overload_int (aTHX_ a, b, third);
#line 4390 "Float128.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Float128__overload_sqrt); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Float128__overload_sqrt)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, third");
    {
	SV *	a = ST(0)
;
	SV *	b = ST(1)
;
	SV *	third = ST(2)
;
	SV *	RETVAL;
#line 3558 "Float128.xs"
  RETVAL = _overload_sqrt (aTHX_ a, b, third);
#line 4414 "Float128.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Float128__overload_log); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Float128__overload_log)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, third");
    {
	SV *	a = ST(0)
;
	SV *	b = ST(1)
;
	SV *	third = ST(2)
;
	SV *	RETVAL;
#line 3567 "Float128.xs"
  RETVAL = _overload_log (aTHX_ a, b, third);
#line 4438 "Float128.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Float128__overload_exp); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Float128__overload_exp)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, third");
    {
	SV *	a = ST(0)
;
	SV *	b = ST(1)
;
	SV *	third = ST(2)
;
	SV *	RETVAL;
#line 3576 "Float128.xs"
  RETVAL = _overload_exp (aTHX_ a, b, third);
#line 4462 "Float128.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Float128__overload_sin); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Float128__overload_sin)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, third");
    {
	SV *	a = ST(0)
;
	SV *	b = ST(1)
;
	SV *	third = ST(2)
;
	SV *	RETVAL;
#line 3585 "Float128.xs"
  RETVAL = _overload_sin (aTHX_ a, b, third);
#line 4486 "Float128.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Float128__overload_cos); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Float128__overload_cos)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, third");
    {
	SV *	a = ST(0)
;
	SV *	b = ST(1)
;
	SV *	third = ST(2)
;
	SV *	RETVAL;
#line 3594 "Float128.xs"
  RETVAL = _overload_cos (aTHX_ a, b, third);
#line 4510 "Float128.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Float128__overload_atan2); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Float128__overload_atan2)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, third");
    {
	SV *	a = ST(0)
;
	SV *	b = ST(1)
;
	SV *	third = ST(2)
;
	SV *	RETVAL;
#line 3603 "Float128.xs"
  RETVAL = _overload_atan2 (aTHX_ a, b, third);
#line 4534 "Float128.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Float128__overload_inc); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Float128__overload_inc)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, third");
    {
	SV *	a = ST(0)
;
	SV *	b = ST(1)
;
	SV *	third = ST(2)
;
	SV *	RETVAL;
#line 3612 "Float128.xs"
  RETVAL = _overload_inc (aTHX_ a, b, third);
#line 4558 "Float128.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Float128__overload_dec); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Float128__overload_dec)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, third");
    {
	SV *	a = ST(0)
;
	SV *	b = ST(1)
;
	SV *	third = ST(2)
;
	SV *	RETVAL;
#line 3621 "Float128.xs"
  RETVAL = _overload_dec (aTHX_ a, b, third);
#line 4582 "Float128.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Float128__overload_pow); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Float128__overload_pow)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, third");
    {
	SV *	a = ST(0)
;
	SV *	b = ST(1)
;
	SV *	third = ST(2)
;
	SV *	RETVAL;
#line 3630 "Float128.xs"
  RETVAL = _overload_pow (aTHX_ a, b, third);
#line 4606 "Float128.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Float128__overload_pow_eq); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Float128__overload_pow_eq)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "a, b, third");
    {
	SV *	a = ST(0)
;
	SV *	b = ST(1)
;
	SV *	third = ST(2)
;
	SV *	RETVAL;
#line 3639 "Float128.xs"
  RETVAL = _overload_pow_eq (aTHX_ a, b, third);
#line 4630 "Float128.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Float128_cmp2NV); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Float128_cmp2NV)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "flt128_obj, sv");
    {
	SV *	flt128_obj = ST(0)
;
	SV *	sv = ST(1)
;
	SV *	RETVAL;
#line 3647 "Float128.xs"
  RETVAL = cmp2NV (aTHX_ flt128_obj, sv);
#line 4652 "Float128.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Float128_F128toNV); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Float128_F128toNV)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "f");
    {
	SV *	f = ST(0)
;
	SV *	RETVAL;
#line 3654 "Float128.xs"
  RETVAL = F128toNV (aTHX_ f);
#line 4672 "Float128.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Float128__FLT128_MAX); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Float128__FLT128_MAX)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	SV *	RETVAL;
#line 3660 "Float128.xs"
  RETVAL = _FLT128_MAX (aTHX);
#line 4690 "Float128.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Float128__FLT128_MIN); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Float128__FLT128_MIN)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	SV *	RETVAL;
#line 3667 "Float128.xs"
  RETVAL = _FLT128_MIN (aTHX);
#line 4708 "Float128.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Float128__FLT128_EPSILON); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Float128__FLT128_EPSILON)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	SV *	RETVAL;
#line 3674 "Float128.xs"
  RETVAL = _FLT128_EPSILON (aTHX);
#line 4726 "Float128.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Float128__FLT128_DENORM_MIN); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Float128__FLT128_DENORM_MIN)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	SV *	RETVAL;
#line 3681 "Float128.xs"
  RETVAL = _FLT128_DENORM_MIN (aTHX);
#line 4744 "Float128.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Float128__FLT128_MANT_DIG); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Float128__FLT128_MANT_DIG)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	int	RETVAL;
	dXSTARG;

	RETVAL = _FLT128_MANT_DIG();
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Float128__FLT128_MIN_EXP); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Float128__FLT128_MIN_EXP)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	int	RETVAL;
	dXSTARG;

	RETVAL = _FLT128_MIN_EXP();
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Float128__FLT128_MAX_EXP); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Float128__FLT128_MAX_EXP)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	int	RETVAL;
	dXSTARG;

	RETVAL = _FLT128_MAX_EXP();
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Float128__FLT128_MIN_10_EXP); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Float128__FLT128_MIN_10_EXP)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	int	RETVAL;
	dXSTARG;

	RETVAL = _FLT128_MIN_10_EXP();
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Float128__FLT128_MAX_10_EXP); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Float128__FLT128_MAX_10_EXP)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	int	RETVAL;
	dXSTARG;

	RETVAL = _FLT128_MAX_10_EXP();
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Float128__M_Eq); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Float128__M_Eq)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	SV *	RETVAL;
#line 3708 "Float128.xs"
  RETVAL = _M_Eq (aTHX);
#line 4847 "Float128.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Float128__M_LOG2Eq); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Float128__M_LOG2Eq)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	SV *	RETVAL;
#line 3715 "Float128.xs"
  RETVAL = _M_LOG2Eq (aTHX);
#line 4865 "Float128.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Float128__M_LOG10Eq); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Float128__M_LOG10Eq)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	SV *	RETVAL;
#line 3722 "Float128.xs"
  RETVAL = _M_LOG10Eq (aTHX);
#line 4883 "Float128.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Float128__M_LN2q); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Float128__M_LN2q)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	SV *	RETVAL;
#line 3729 "Float128.xs"
  RETVAL = _M_LN2q (aTHX);
#line 4901 "Float128.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Float128__M_LN10q); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Float128__M_LN10q)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	SV *	RETVAL;
#line 3736 "Float128.xs"
  RETVAL = _M_LN10q (aTHX);
#line 4919 "Float128.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Float128__M_PIq); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Float128__M_PIq)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	SV *	RETVAL;
#line 3743 "Float128.xs"
  RETVAL = _M_PIq (aTHX);
#line 4937 "Float128.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Float128__M_PI_2q); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Float128__M_PI_2q)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	SV *	RETVAL;
#line 3750 "Float128.xs"
  RETVAL = _M_PI_2q (aTHX);
#line 4955 "Float128.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Float128__M_PI_4q); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Float128__M_PI_4q)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	SV *	RETVAL;
#line 3757 "Float128.xs"
  RETVAL = _M_PI_4q (aTHX);
#line 4973 "Float128.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Float128__M_1_PIq); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Float128__M_1_PIq)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	SV *	RETVAL;
#line 3764 "Float128.xs"
  RETVAL = _M_1_PIq (aTHX);
#line 4991 "Float128.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Float128__M_2_PIq); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Float128__M_2_PIq)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	SV *	RETVAL;
#line 3771 "Float128.xs"
  RETVAL = _M_2_PIq (aTHX);
#line 5009 "Float128.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Float128__M_2_SQRTPIq); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Float128__M_2_SQRTPIq)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	SV *	RETVAL;
#line 3778 "Float128.xs"
  RETVAL = _M_2_SQRTPIq (aTHX);
#line 5027 "Float128.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Float128__M_SQRT2q); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Float128__M_SQRT2q)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	SV *	RETVAL;
#line 3785 "Float128.xs"
  RETVAL = _M_SQRT2q (aTHX);
#line 5045 "Float128.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Float128__M_SQRT1_2q); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Float128__M_SQRT1_2q)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	SV *	RETVAL;
#line 3792 "Float128.xs"
  RETVAL = _M_SQRT1_2q (aTHX);
#line 5063 "Float128.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Float128__f128_bytes); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Float128__f128_bytes)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "sv");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	sv = ST(0)
;
#line 3800 "Float128.xs"
        I32* temp;
#line 5084 "Float128.c"
#line 3802 "Float128.xs"
        temp = PL_markstack_ptr++;
        _f128_bytes(aTHX_ sv);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 5095 "Float128.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__Float128_acos_F128); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Float128_acos_F128)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "rop, op");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	float128 *            rop = INT2PTR(float128 *, SvIVX(SvRV(ST(0))))
;
	float128 *            op = INT2PTR(float128 *, SvIVX(SvRV(ST(1))))
;
#line 3817 "Float128.xs"
        I32* temp;
#line 5117 "Float128.c"
#line 3819 "Float128.xs"
        temp = PL_markstack_ptr++;
        acos_F128(rop, op);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 5128 "Float128.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__Float128_acosh_F128); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Float128_acosh_F128)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "rop, op");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	float128 *            rop = INT2PTR(float128 *, SvIVX(SvRV(ST(0))))
;
	float128 *            op = INT2PTR(float128 *, SvIVX(SvRV(ST(1))))
;
#line 3834 "Float128.xs"
        I32* temp;
#line 5150 "Float128.c"
#line 3836 "Float128.xs"
        temp = PL_markstack_ptr++;
        acosh_F128(rop, op);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 5161 "Float128.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__Float128_asin_F128); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Float128_asin_F128)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "rop, op");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	float128 *            rop = INT2PTR(float128 *, SvIVX(SvRV(ST(0))))
;
	float128 *            op = INT2PTR(float128 *, SvIVX(SvRV(ST(1))))
;
#line 3851 "Float128.xs"
        I32* temp;
#line 5183 "Float128.c"
#line 3853 "Float128.xs"
        temp = PL_markstack_ptr++;
        asin_F128(rop, op);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 5194 "Float128.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__Float128_asinh_F128); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Float128_asinh_F128)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "rop, op");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	float128 *            rop = INT2PTR(float128 *, SvIVX(SvRV(ST(0))))
;
	float128 *            op = INT2PTR(float128 *, SvIVX(SvRV(ST(1))))
;
#line 3868 "Float128.xs"
        I32* temp;
#line 5216 "Float128.c"
#line 3870 "Float128.xs"
        temp = PL_markstack_ptr++;
        asinh_F128(rop, op);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 5227 "Float128.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__Float128_atan_F128); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Float128_atan_F128)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "rop, op");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	float128 *            rop = INT2PTR(float128 *, SvIVX(SvRV(ST(0))))
;
	float128 *            op = INT2PTR(float128 *, SvIVX(SvRV(ST(1))))
;
#line 3885 "Float128.xs"
        I32* temp;
#line 5249 "Float128.c"
#line 3887 "Float128.xs"
        temp = PL_markstack_ptr++;
        atan_F128(rop, op);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 5260 "Float128.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__Float128_atanh_F128); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Float128_atanh_F128)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "rop, op");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	float128 *            rop = INT2PTR(float128 *, SvIVX(SvRV(ST(0))))
;
	float128 *            op = INT2PTR(float128 *, SvIVX(SvRV(ST(1))))
;
#line 3902 "Float128.xs"
        I32* temp;
#line 5282 "Float128.c"
#line 3904 "Float128.xs"
        temp = PL_markstack_ptr++;
        atanh_F128(rop, op);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 5293 "Float128.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__Float128_atan2_F128); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Float128_atan2_F128)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "rop, op1, op2");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	float128 *            rop = INT2PTR(float128 *, SvIVX(SvRV(ST(0))))
;
	float128 *            op1 = INT2PTR(float128 *, SvIVX(SvRV(ST(1))))
;
	float128 *            op2 = INT2PTR(float128 *, SvIVX(SvRV(ST(2))))
;
#line 3920 "Float128.xs"
        I32* temp;
#line 5317 "Float128.c"
#line 3922 "Float128.xs"
        temp = PL_markstack_ptr++;
        atan2_F128(rop, op1, op2);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 5328 "Float128.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__Float128_cbrt_F128); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Float128_cbrt_F128)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "rop, op");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	float128 *            rop = INT2PTR(float128 *, SvIVX(SvRV(ST(0))))
;
	float128 *            op = INT2PTR(float128 *, SvIVX(SvRV(ST(1))))
;
#line 3937 "Float128.xs"
        I32* temp;
#line 5350 "Float128.c"
#line 3939 "Float128.xs"
        temp = PL_markstack_ptr++;
        cbrt_F128(rop, op);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 5361 "Float128.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__Float128_ceil_F128); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Float128_ceil_F128)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "rop, op");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	float128 *            rop = INT2PTR(float128 *, SvIVX(SvRV(ST(0))))
;
	float128 *            op = INT2PTR(float128 *, SvIVX(SvRV(ST(1))))
;
#line 3954 "Float128.xs"
        I32* temp;
#line 5383 "Float128.c"
#line 3956 "Float128.xs"
        temp = PL_markstack_ptr++;
        ceil_F128(rop, op);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 5394 "Float128.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__Float128_copysign_F128); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Float128_copysign_F128)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "rop, op1, op2");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	float128 *            rop = INT2PTR(float128 *, SvIVX(SvRV(ST(0))))
;
	float128 *            op1 = INT2PTR(float128 *, SvIVX(SvRV(ST(1))))
;
	float128 *            op2 = INT2PTR(float128 *, SvIVX(SvRV(ST(2))))
;
#line 3972 "Float128.xs"
        I32* temp;
#line 5418 "Float128.c"
#line 3974 "Float128.xs"
        temp = PL_markstack_ptr++;
        copysign_F128(rop, op1, op2);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 5429 "Float128.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__Float128_cosh_F128); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Float128_cosh_F128)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "rop, op");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	float128 *            rop = INT2PTR(float128 *, SvIVX(SvRV(ST(0))))
;
	float128 *            op = INT2PTR(float128 *, SvIVX(SvRV(ST(1))))
;
#line 3989 "Float128.xs"
        I32* temp;
#line 5451 "Float128.c"
#line 3991 "Float128.xs"
        temp = PL_markstack_ptr++;
        cosh_F128(rop, op);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 5462 "Float128.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__Float128_cos_F128); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Float128_cos_F128)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "rop, op");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	float128 *            rop = INT2PTR(float128 *, SvIVX(SvRV(ST(0))))
;
	float128 *            op = INT2PTR(float128 *, SvIVX(SvRV(ST(1))))
;
#line 4006 "Float128.xs"
        I32* temp;
#line 5484 "Float128.c"
#line 4008 "Float128.xs"
        temp = PL_markstack_ptr++;
        cos_F128(rop, op);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 5495 "Float128.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__Float128_erf_F128); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Float128_erf_F128)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "rop, op");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	float128 *            rop = INT2PTR(float128 *, SvIVX(SvRV(ST(0))))
;
	float128 *            op = INT2PTR(float128 *, SvIVX(SvRV(ST(1))))
;
#line 4023 "Float128.xs"
        I32* temp;
#line 5517 "Float128.c"
#line 4025 "Float128.xs"
        temp = PL_markstack_ptr++;
        erf_F128(rop, op);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 5528 "Float128.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__Float128_erfc_F128); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Float128_erfc_F128)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "rop, op");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	float128 *            rop = INT2PTR(float128 *, SvIVX(SvRV(ST(0))))
;
	float128 *            op = INT2PTR(float128 *, SvIVX(SvRV(ST(1))))
;
#line 4040 "Float128.xs"
        I32* temp;
#line 5550 "Float128.c"
#line 4042 "Float128.xs"
        temp = PL_markstack_ptr++;
        erfc_F128(rop, op);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 5561 "Float128.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__Float128_exp_F128); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Float128_exp_F128)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "rop, op");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	float128 *            rop = INT2PTR(float128 *, SvIVX(SvRV(ST(0))))
;
	float128 *            op = INT2PTR(float128 *, SvIVX(SvRV(ST(1))))
;
#line 4057 "Float128.xs"
        I32* temp;
#line 5583 "Float128.c"
#line 4059 "Float128.xs"
        temp = PL_markstack_ptr++;
        exp_F128(rop, op);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 5594 "Float128.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__Float128_expm1_F128); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Float128_expm1_F128)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "rop, op");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	float128 *            rop = INT2PTR(float128 *, SvIVX(SvRV(ST(0))))
;
	float128 *            op = INT2PTR(float128 *, SvIVX(SvRV(ST(1))))
;
#line 4074 "Float128.xs"
        I32* temp;
#line 5616 "Float128.c"
#line 4076 "Float128.xs"
        temp = PL_markstack_ptr++;
        expm1_F128(rop, op);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 5627 "Float128.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__Float128_fabs_F128); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Float128_fabs_F128)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "rop, op");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	float128 *            rop = INT2PTR(float128 *, SvIVX(SvRV(ST(0))))
;
	float128 *            op = INT2PTR(float128 *, SvIVX(SvRV(ST(1))))
;
#line 4091 "Float128.xs"
        I32* temp;
#line 5649 "Float128.c"
#line 4093 "Float128.xs"
        temp = PL_markstack_ptr++;
        fabs_F128(rop, op);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 5660 "Float128.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__Float128_fdim_F128); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Float128_fdim_F128)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "rop, op1, op2");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	float128 *            rop = INT2PTR(float128 *, SvIVX(SvRV(ST(0))))
;
	float128 *            op1 = INT2PTR(float128 *, SvIVX(SvRV(ST(1))))
;
	float128 *            op2 = INT2PTR(float128 *, SvIVX(SvRV(ST(2))))
;
#line 4109 "Float128.xs"
        I32* temp;
#line 5684 "Float128.c"
#line 4111 "Float128.xs"
        temp = PL_markstack_ptr++;
        fdim_F128(rop, op1, op2);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 5695 "Float128.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__Float128_finite_F128); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Float128_finite_F128)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "op");
    {
	float128 *            op = INT2PTR(float128 *, SvIVX(SvRV(ST(0))))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = finite_F128(op);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Float128_floor_F128); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Float128_floor_F128)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "rop, op");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	float128 *            rop = INT2PTR(float128 *, SvIVX(SvRV(ST(0))))
;
	float128 *            op = INT2PTR(float128 *, SvIVX(SvRV(ST(1))))
;
#line 4130 "Float128.xs"
        I32* temp;
#line 5736 "Float128.c"
#line 4132 "Float128.xs"
        temp = PL_markstack_ptr++;
        floor_F128(rop, op);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 5747 "Float128.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__Float128_fma_F128); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Float128_fma_F128)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "rop, op1, op2, op3");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	float128 *            rop = INT2PTR(float128 *, SvIVX(SvRV(ST(0))))
;
	float128 *            op1 = INT2PTR(float128 *, SvIVX(SvRV(ST(1))))
;
	float128 *            op2 = INT2PTR(float128 *, SvIVX(SvRV(ST(2))))
;
	float128 *            op3 = INT2PTR(float128 *, SvIVX(SvRV(ST(3))))
;
#line 4149 "Float128.xs"
        I32* temp;
#line 5773 "Float128.c"
#line 4151 "Float128.xs"
        temp = PL_markstack_ptr++;
        fma_F128(rop, op1, op2, op3);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 5784 "Float128.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__Float128_fmax_F128); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Float128_fmax_F128)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "rop, op1, op2");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	float128 *            rop = INT2PTR(float128 *, SvIVX(SvRV(ST(0))))
;
	float128 *            op1 = INT2PTR(float128 *, SvIVX(SvRV(ST(1))))
;
	float128 *            op2 = INT2PTR(float128 *, SvIVX(SvRV(ST(2))))
;
#line 4167 "Float128.xs"
        I32* temp;
#line 5808 "Float128.c"
#line 4169 "Float128.xs"
        temp = PL_markstack_ptr++;
        fmax_F128(rop, op1, op2);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 5819 "Float128.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__Float128_fmin_F128); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Float128_fmin_F128)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "rop, op1, op2");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	float128 *            rop = INT2PTR(float128 *, SvIVX(SvRV(ST(0))))
;
	float128 *            op1 = INT2PTR(float128 *, SvIVX(SvRV(ST(1))))
;
	float128 *            op2 = INT2PTR(float128 *, SvIVX(SvRV(ST(2))))
;
#line 4185 "Float128.xs"
        I32* temp;
#line 5843 "Float128.c"
#line 4187 "Float128.xs"
        temp = PL_markstack_ptr++;
        fmin_F128(rop, op1, op2);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 5854 "Float128.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__Float128_fmod_F128); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Float128_fmod_F128)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "rop, op1, op2");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	float128 *            rop = INT2PTR(float128 *, SvIVX(SvRV(ST(0))))
;
	float128 *            op1 = INT2PTR(float128 *, SvIVX(SvRV(ST(1))))
;
	float128 *            op2 = INT2PTR(float128 *, SvIVX(SvRV(ST(2))))
;
#line 4203 "Float128.xs"
        I32* temp;
#line 5878 "Float128.c"
#line 4205 "Float128.xs"
        temp = PL_markstack_ptr++;
        fmod_F128(rop, op1, op2);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 5889 "Float128.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__Float128_hypot_F128); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Float128_hypot_F128)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "rop, op1, op2");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	float128 *            rop = INT2PTR(float128 *, SvIVX(SvRV(ST(0))))
;
	float128 *            op1 = INT2PTR(float128 *, SvIVX(SvRV(ST(1))))
;
	float128 *            op2 = INT2PTR(float128 *, SvIVX(SvRV(ST(2))))
;
#line 4221 "Float128.xs"
        I32* temp;
#line 5913 "Float128.c"
#line 4223 "Float128.xs"
        temp = PL_markstack_ptr++;
        hypot_F128(rop, op1, op2);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 5924 "Float128.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__Float128_frexp_F128); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Float128_frexp_F128)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "frac, exp, op");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	float128 *            frac = INT2PTR(float128 *, SvIVX(SvRV(ST(0))))
;
	SV *	exp = ST(1)
;
	float128 *            op = INT2PTR(float128 *, SvIVX(SvRV(ST(2))))
;
#line 4239 "Float128.xs"
        I32* temp;
#line 5948 "Float128.c"
#line 4241 "Float128.xs"
        temp = PL_markstack_ptr++;
        frexp_F128(aTHX_ frac, exp, op);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 5959 "Float128.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__Float128_ldexp_F128); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Float128_ldexp_F128)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "rop, op, pow");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	float128 *            rop = INT2PTR(float128 *, SvIVX(SvRV(ST(0))))
;
	float128 *            op = INT2PTR(float128 *, SvIVX(SvRV(ST(1))))
;
	int	pow = (int)SvIV(ST(2))
;
#line 4257 "Float128.xs"
        I32* temp;
#line 5983 "Float128.c"
#line 4259 "Float128.xs"
        temp = PL_markstack_ptr++;
        ldexp_F128(rop, op, pow);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 5994 "Float128.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__Float128_isinf_F128); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Float128_isinf_F128)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "op");
    {
	float128 *            op = INT2PTR(float128 *, SvIVX(SvRV(ST(0))))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = isinf_F128(op);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Float128_ilogb_F128); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Float128_ilogb_F128)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "op");
    {
	float128 *            op = INT2PTR(float128 *, SvIVX(SvRV(ST(0))))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = ilogb_F128(op);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Float128_isnan_F128); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Float128_isnan_F128)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "op");
    {
	float128 *            op = INT2PTR(float128 *, SvIVX(SvRV(ST(0))))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = isnan_F128(op);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Float128_j0_F128); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Float128_j0_F128)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "rop, op");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	float128 *            rop = INT2PTR(float128 *, SvIVX(SvRV(ST(0))))
;
	float128 *            op = INT2PTR(float128 *, SvIVX(SvRV(ST(1))))
;
#line 4286 "Float128.xs"
        I32* temp;
#line 6073 "Float128.c"
#line 4288 "Float128.xs"
        temp = PL_markstack_ptr++;
        j0_F128(rop, op);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 6084 "Float128.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__Float128_j1_F128); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Float128_j1_F128)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "rop, op");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	float128 *            rop = INT2PTR(float128 *, SvIVX(SvRV(ST(0))))
;
	float128 *            op = INT2PTR(float128 *, SvIVX(SvRV(ST(1))))
;
#line 4303 "Float128.xs"
        I32* temp;
#line 6106 "Float128.c"
#line 4305 "Float128.xs"
        temp = PL_markstack_ptr++;
        j1_F128(rop, op);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 6117 "Float128.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__Float128_jn_F128); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Float128_jn_F128)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "rop, n, op");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	float128 *            rop = INT2PTR(float128 *, SvIVX(SvRV(ST(0))))
;
	int	n = (int)SvIV(ST(1))
;
	float128 *            op = INT2PTR(float128 *, SvIVX(SvRV(ST(2))))
;
#line 4321 "Float128.xs"
        I32* temp;
#line 6141 "Float128.c"
#line 4323 "Float128.xs"
        temp = PL_markstack_ptr++;
        jn_F128(rop, n, op);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 6152 "Float128.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__Float128_lgamma_F128); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Float128_lgamma_F128)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "rop, op");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	float128 *            rop = INT2PTR(float128 *, SvIVX(SvRV(ST(0))))
;
	float128 *            op = INT2PTR(float128 *, SvIVX(SvRV(ST(1))))
;
#line 4338 "Float128.xs"
        I32* temp;
#line 6174 "Float128.c"
#line 4340 "Float128.xs"
        temp = PL_markstack_ptr++;
        lgamma_F128(rop, op);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 6185 "Float128.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__Float128_llrint_F128); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Float128_llrint_F128)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "op");
    {
	float128 *            op = INT2PTR(float128 *, SvIVX(SvRV(ST(0))))
;
	SV *	RETVAL;
#line 4354 "Float128.xs"
  RETVAL = llrint_F128 (aTHX_ op);
#line 6204 "Float128.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Float128_llround_F128); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Float128_llround_F128)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "op");
    {
	float128 *            op = INT2PTR(float128 *, SvIVX(SvRV(ST(0))))
;
	SV *	RETVAL;
#line 4361 "Float128.xs"
  RETVAL = llround_F128 (aTHX_ op);
#line 6224 "Float128.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Float128_lrint_F128); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Float128_lrint_F128)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "op");
    {
	float128 *            op = INT2PTR(float128 *, SvIVX(SvRV(ST(0))))
;
	SV *	RETVAL;
#line 4368 "Float128.xs"
  RETVAL = lrint_F128 (aTHX_ op);
#line 6244 "Float128.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Float128_lround_F128); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Float128_lround_F128)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "op");
    {
	float128 *            op = INT2PTR(float128 *, SvIVX(SvRV(ST(0))))
;
	SV *	RETVAL;
#line 4375 "Float128.xs"
  RETVAL = lround_F128 (aTHX_ op);
#line 6264 "Float128.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Float128_log_F128); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Float128_log_F128)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "rop, op");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	float128 *            rop = INT2PTR(float128 *, SvIVX(SvRV(ST(0))))
;
	float128 *            op = INT2PTR(float128 *, SvIVX(SvRV(ST(1))))
;
#line 4383 "Float128.xs"
        I32* temp;
#line 6287 "Float128.c"
#line 4385 "Float128.xs"
        temp = PL_markstack_ptr++;
        log_F128(rop, op);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 6298 "Float128.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__Float128_log10_F128); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Float128_log10_F128)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "rop, op");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	float128 *            rop = INT2PTR(float128 *, SvIVX(SvRV(ST(0))))
;
	float128 *            op = INT2PTR(float128 *, SvIVX(SvRV(ST(1))))
;
#line 4400 "Float128.xs"
        I32* temp;
#line 6320 "Float128.c"
#line 4402 "Float128.xs"
        temp = PL_markstack_ptr++;
        log10_F128(rop, op);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 6331 "Float128.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__Float128_log2_F128); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Float128_log2_F128)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "rop, op");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	float128 *            rop = INT2PTR(float128 *, SvIVX(SvRV(ST(0))))
;
	float128 *            op = INT2PTR(float128 *, SvIVX(SvRV(ST(1))))
;
#line 4417 "Float128.xs"
        I32* temp;
#line 6353 "Float128.c"
#line 4419 "Float128.xs"
        temp = PL_markstack_ptr++;
        log2_F128(rop, op);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 6364 "Float128.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__Float128_log1p_F128); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Float128_log1p_F128)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "rop, op");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	float128 *            rop = INT2PTR(float128 *, SvIVX(SvRV(ST(0))))
;
	float128 *            op = INT2PTR(float128 *, SvIVX(SvRV(ST(1))))
;
#line 4434 "Float128.xs"
        I32* temp;
#line 6386 "Float128.c"
#line 4436 "Float128.xs"
        temp = PL_markstack_ptr++;
        log1p_F128(rop, op);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 6397 "Float128.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__Float128_modf_F128); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Float128_modf_F128)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "integer, frac, op");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	float128 *            integer = INT2PTR(float128 *, SvIVX(SvRV(ST(0))))
;
	float128 *            frac = INT2PTR(float128 *, SvIVX(SvRV(ST(1))))
;
	float128 *            op = INT2PTR(float128 *, SvIVX(SvRV(ST(2))))
;
#line 4452 "Float128.xs"
        I32* temp;
#line 6421 "Float128.c"
#line 4454 "Float128.xs"
        temp = PL_markstack_ptr++;
        modf_F128(integer, frac, op);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 6432 "Float128.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__Float128_nan_F128); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Float128_nan_F128)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "rop, op");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	float128 *            rop = INT2PTR(float128 *, SvIVX(SvRV(ST(0))))
;
	SV *	op = ST(1)
;
#line 4469 "Float128.xs"
        I32* temp;
#line 6454 "Float128.c"
#line 4471 "Float128.xs"
        temp = PL_markstack_ptr++;
        nan_F128(aTHX_ rop, op);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 6465 "Float128.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__Float128_nearbyint_F128); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Float128_nearbyint_F128)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "rop, op");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	float128 *            rop = INT2PTR(float128 *, SvIVX(SvRV(ST(0))))
;
	float128 *            op = INT2PTR(float128 *, SvIVX(SvRV(ST(1))))
;
#line 4486 "Float128.xs"
        I32* temp;
#line 6487 "Float128.c"
#line 4488 "Float128.xs"
        temp = PL_markstack_ptr++;
        nearbyint_F128(rop, op);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 6498 "Float128.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__Float128_nextafter_F128); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Float128_nextafter_F128)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "rop, op1, op2");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	float128 *            rop = INT2PTR(float128 *, SvIVX(SvRV(ST(0))))
;
	float128 *            op1 = INT2PTR(float128 *, SvIVX(SvRV(ST(1))))
;
	float128 *            op2 = INT2PTR(float128 *, SvIVX(SvRV(ST(2))))
;
#line 4504 "Float128.xs"
        I32* temp;
#line 6522 "Float128.c"
#line 4506 "Float128.xs"
        temp = PL_markstack_ptr++;
        nextafter_F128(rop, op1, op2);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 6533 "Float128.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__Float128_pow_F128); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Float128_pow_F128)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "rop, op1, op2");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	float128 *            rop = INT2PTR(float128 *, SvIVX(SvRV(ST(0))))
;
	float128 *            op1 = INT2PTR(float128 *, SvIVX(SvRV(ST(1))))
;
	float128 *            op2 = INT2PTR(float128 *, SvIVX(SvRV(ST(2))))
;
#line 4522 "Float128.xs"
        I32* temp;
#line 6557 "Float128.c"
#line 4524 "Float128.xs"
        temp = PL_markstack_ptr++;
        pow_F128(rop, op1, op2);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 6568 "Float128.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__Float128_remainder_F128); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Float128_remainder_F128)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "rop, op1, op2");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	float128 *            rop = INT2PTR(float128 *, SvIVX(SvRV(ST(0))))
;
	float128 *            op1 = INT2PTR(float128 *, SvIVX(SvRV(ST(1))))
;
	float128 *            op2 = INT2PTR(float128 *, SvIVX(SvRV(ST(2))))
;
#line 4540 "Float128.xs"
        I32* temp;
#line 6592 "Float128.c"
#line 4542 "Float128.xs"
        temp = PL_markstack_ptr++;
        remainder_F128(rop, op1, op2);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 6603 "Float128.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__Float128_remquo_F128); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Float128_remquo_F128)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "rop1, rop2, op1, op2");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	float128 *            rop1 = INT2PTR(float128 *, SvIVX(SvRV(ST(0))))
;
	SV *	rop2 = ST(1)
;
	float128 *            op1 = INT2PTR(float128 *, SvIVX(SvRV(ST(2))))
;
	float128 *            op2 = INT2PTR(float128 *, SvIVX(SvRV(ST(3))))
;
#line 4559 "Float128.xs"
        I32* temp;
#line 6629 "Float128.c"
#line 4561 "Float128.xs"
        temp = PL_markstack_ptr++;
        remquo_F128(aTHX_ rop1, rop2, op1, op2);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 6640 "Float128.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__Float128_rint_F128); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Float128_rint_F128)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "rop, op");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	float128 *            rop = INT2PTR(float128 *, SvIVX(SvRV(ST(0))))
;
	float128 *            op = INT2PTR(float128 *, SvIVX(SvRV(ST(1))))
;
#line 4576 "Float128.xs"
        I32* temp;
#line 6662 "Float128.c"
#line 4578 "Float128.xs"
        temp = PL_markstack_ptr++;
        rint_F128(rop, op);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 6673 "Float128.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__Float128_round_F128); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Float128_round_F128)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "rop, op");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	float128 *            rop = INT2PTR(float128 *, SvIVX(SvRV(ST(0))))
;
	float128 *            op = INT2PTR(float128 *, SvIVX(SvRV(ST(1))))
;
#line 4593 "Float128.xs"
        I32* temp;
#line 6695 "Float128.c"
#line 4595 "Float128.xs"
        temp = PL_markstack_ptr++;
        round_F128(rop, op);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 6706 "Float128.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__Float128_scalbln_F128); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Float128_scalbln_F128)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "rop, op1, op2");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	float128 *            rop = INT2PTR(float128 *, SvIVX(SvRV(ST(0))))
;
	float128 *            op1 = INT2PTR(float128 *, SvIVX(SvRV(ST(1))))
;
	long	op2 = (long)SvIV(ST(2))
;
#line 4611 "Float128.xs"
        I32* temp;
#line 6730 "Float128.c"
#line 4613 "Float128.xs"
        temp = PL_markstack_ptr++;
        scalbln_F128(rop, op1, op2);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 6741 "Float128.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__Float128_scalbn_F128); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Float128_scalbn_F128)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "rop, op1, op2");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	float128 *            rop = INT2PTR(float128 *, SvIVX(SvRV(ST(0))))
;
	float128 *            op1 = INT2PTR(float128 *, SvIVX(SvRV(ST(1))))
;
	int	op2 = (int)SvIV(ST(2))
;
#line 4629 "Float128.xs"
        I32* temp;
#line 6765 "Float128.c"
#line 4631 "Float128.xs"
        temp = PL_markstack_ptr++;
        scalbn_F128(rop, op1, op2);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 6776 "Float128.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__Float128_signbit_F128); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Float128_signbit_F128)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "op");
    {
	float128 *            op = INT2PTR(float128 *, SvIVX(SvRV(ST(0))))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = signbit_F128(op);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Float128_sincos_F128); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Float128_sincos_F128)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "sin, cos, op");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	float128 *            sin = INT2PTR(float128 *, SvIVX(SvRV(ST(0))))
;
	float128 *            cos = INT2PTR(float128 *, SvIVX(SvRV(ST(1))))
;
	float128 *            op = INT2PTR(float128 *, SvIVX(SvRV(ST(2))))
;
#line 4651 "Float128.xs"
        I32* temp;
#line 6819 "Float128.c"
#line 4653 "Float128.xs"
        temp = PL_markstack_ptr++;
        sincos_F128(sin, cos, op);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 6830 "Float128.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__Float128_sinh_F128); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Float128_sinh_F128)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "rop, op");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	float128 *            rop = INT2PTR(float128 *, SvIVX(SvRV(ST(0))))
;
	float128 *            op = INT2PTR(float128 *, SvIVX(SvRV(ST(1))))
;
#line 4668 "Float128.xs"
        I32* temp;
#line 6852 "Float128.c"
#line 4670 "Float128.xs"
        temp = PL_markstack_ptr++;
        sinh_F128(rop, op);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 6863 "Float128.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__Float128_sin_F128); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Float128_sin_F128)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "rop, op");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	float128 *            rop = INT2PTR(float128 *, SvIVX(SvRV(ST(0))))
;
	float128 *            op = INT2PTR(float128 *, SvIVX(SvRV(ST(1))))
;
#line 4685 "Float128.xs"
        I32* temp;
#line 6885 "Float128.c"
#line 4687 "Float128.xs"
        temp = PL_markstack_ptr++;
        sin_F128(rop, op);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 6896 "Float128.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__Float128_sqrt_F128); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Float128_sqrt_F128)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "rop, op");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	float128 *            rop = INT2PTR(float128 *, SvIVX(SvRV(ST(0))))
;
	float128 *            op = INT2PTR(float128 *, SvIVX(SvRV(ST(1))))
;
#line 4702 "Float128.xs"
        I32* temp;
#line 6918 "Float128.c"
#line 4704 "Float128.xs"
        temp = PL_markstack_ptr++;
        sqrt_F128(rop, op);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 6929 "Float128.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__Float128_tan_F128); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Float128_tan_F128)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "rop, op");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	float128 *            rop = INT2PTR(float128 *, SvIVX(SvRV(ST(0))))
;
	float128 *            op = INT2PTR(float128 *, SvIVX(SvRV(ST(1))))
;
#line 4719 "Float128.xs"
        I32* temp;
#line 6951 "Float128.c"
#line 4721 "Float128.xs"
        temp = PL_markstack_ptr++;
        tan_F128(rop, op);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 6962 "Float128.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__Float128_tanh_F128); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Float128_tanh_F128)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "rop, op");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	float128 *            rop = INT2PTR(float128 *, SvIVX(SvRV(ST(0))))
;
	float128 *            op = INT2PTR(float128 *, SvIVX(SvRV(ST(1))))
;
#line 4736 "Float128.xs"
        I32* temp;
#line 6984 "Float128.c"
#line 4738 "Float128.xs"
        temp = PL_markstack_ptr++;
        tanh_F128(rop, op);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 6995 "Float128.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__Float128_tgamma_F128); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Float128_tgamma_F128)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "rop, op");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	float128 *            rop = INT2PTR(float128 *, SvIVX(SvRV(ST(0))))
;
	float128 *            op = INT2PTR(float128 *, SvIVX(SvRV(ST(1))))
;
#line 4753 "Float128.xs"
        I32* temp;
#line 7017 "Float128.c"
#line 4755 "Float128.xs"
        temp = PL_markstack_ptr++;
        tgamma_F128(rop, op);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 7028 "Float128.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__Float128_trunc_F128); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Float128_trunc_F128)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "rop, op");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	float128 *            rop = INT2PTR(float128 *, SvIVX(SvRV(ST(0))))
;
	float128 *            op = INT2PTR(float128 *, SvIVX(SvRV(ST(1))))
;
#line 4770 "Float128.xs"
        I32* temp;
#line 7050 "Float128.c"
#line 4772 "Float128.xs"
        temp = PL_markstack_ptr++;
        trunc_F128(rop, op);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 7061 "Float128.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__Float128_y0_F128); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Float128_y0_F128)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "rop, op");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	float128 *            rop = INT2PTR(float128 *, SvIVX(SvRV(ST(0))))
;
	float128 *            op = INT2PTR(float128 *, SvIVX(SvRV(ST(1))))
;
#line 4787 "Float128.xs"
        I32* temp;
#line 7083 "Float128.c"
#line 4789 "Float128.xs"
        temp = PL_markstack_ptr++;
        y0_F128(rop, op);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 7094 "Float128.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__Float128_y1_F128); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Float128_y1_F128)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "rop, op");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	float128 *            rop = INT2PTR(float128 *, SvIVX(SvRV(ST(0))))
;
	float128 *            op = INT2PTR(float128 *, SvIVX(SvRV(ST(1))))
;
#line 4804 "Float128.xs"
        I32* temp;
#line 7116 "Float128.c"
#line 4806 "Float128.xs"
        temp = PL_markstack_ptr++;
        y1_F128(rop, op);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 7127 "Float128.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__Float128_yn_F128); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Float128_yn_F128)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "rop, n, op");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	float128 *            rop = INT2PTR(float128 *, SvIVX(SvRV(ST(0))))
;
	int	n = (int)SvIV(ST(1))
;
	float128 *            op = INT2PTR(float128 *, SvIVX(SvRV(ST(2))))
;
#line 4822 "Float128.xs"
        I32* temp;
#line 7151 "Float128.c"
#line 4824 "Float128.xs"
        temp = PL_markstack_ptr++;
        yn_F128(rop, n, op);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 7162 "Float128.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__Float128__longlong2iv_is_ok); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Float128__longlong2iv_is_ok)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	int	RETVAL;
	dXSTARG;

	RETVAL = _longlong2iv_is_ok();
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Float128__long2iv_is_ok); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Float128__long2iv_is_ok)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	int	RETVAL;
	dXSTARG;

	RETVAL = _long2iv_is_ok();
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Float128__flt_radix); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Float128__flt_radix)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	int	RETVAL;
	dXSTARG;

	RETVAL = _flt_radix();
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Float128__fegetround); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Float128__fegetround)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	SV *	RETVAL;
#line 4849 "Float128.xs"
  RETVAL = _fegetround (aTHX);
#line 7230 "Float128.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Float128_nnumflag); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Float128_nnumflag)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	int	RETVAL;
	dXSTARG;

	RETVAL = nnumflag();
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Float128_clear_nnum); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Float128_clear_nnum)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 4861 "Float128.xs"
        I32* temp;
#line 7266 "Float128.c"
#line 4863 "Float128.xs"
        temp = PL_markstack_ptr++;
        clear_nnum();
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 7277 "Float128.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__Float128_set_nnum); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Float128_set_nnum)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "x");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	int	x = (int)SvIV(ST(0))
;
#line 4877 "Float128.xs"
        I32* temp;
#line 7297 "Float128.c"
#line 4879 "Float128.xs"
        temp = PL_markstack_ptr++;
        set_nnum(x);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 7308 "Float128.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__Float128__lln); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Float128__lln)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "x");
    {
	SV *	x = ST(0)
;
	int	RETVAL;
	dXSTARG;
#line 4893 "Float128.xs"
  RETVAL = _lln (aTHX_ x);
#line 7328 "Float128.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Float128_nok_pokflag); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Float128_nok_pokflag)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	int	RETVAL;
	dXSTARG;

	RETVAL = nok_pokflag();
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Float128_clear_nok_pok); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Float128_clear_nok_pok)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 4904 "Float128.xs"
        I32* temp;
#line 7363 "Float128.c"
#line 4906 "Float128.xs"
        temp = PL_markstack_ptr++;
        clear_nok_pok();
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 7374 "Float128.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__Float128_set_nok_pok); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Float128_set_nok_pok)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "x");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	int	x = (int)SvIV(ST(0))
;
#line 4920 "Float128.xs"
        I32* temp;
#line 7394 "Float128.c"
#line 4922 "Float128.xs"
        temp = PL_markstack_ptr++;
        set_nok_pok(x);
        if (PL_markstack_ptr != temp) {
          /* truly void, because dXSARGS not invoked */
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY; /* return empty stack */
        }
        /* must have used dXSARGS; list context implied */
        return; /* assume stack size is correct */
#line 7405 "Float128.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Math__Float128__SvNOK); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Float128__SvNOK)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "in");
    {
	SV *	in = ST(0)
;
	int	RETVAL;
	dXSTARG;
#line 4936 "Float128.xs"
  RETVAL = _SvNOK (aTHX_ in);
#line 7425 "Float128.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Float128__SvPOK); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Float128__SvPOK)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "in");
    {
	SV *	in = ST(0)
;
	int	RETVAL;
	dXSTARG;
#line 4943 "Float128.xs"
  RETVAL = _SvPOK (aTHX_ in);
#line 7445 "Float128.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Math__Float128__avoid_inf_cast); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Math__Float128__avoid_inf_cast)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	int	RETVAL;
	dXSTARG;

	RETVAL = _avoid_inf_cast();
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}

#ifdef __cplusplus
extern "C"
#endif
XS_EXTERNAL(boot_Math__Float128); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_Math__Float128)
{
#if PERL_VERSION_LE(5, 21, 5)
    dVAR; dXSARGS;
#else
    dVAR; dXSBOOTARGSXSAPIVERCHK;
#endif
#if PERL_VERSION_LE(5, 8, 999) /* PERL_VERSION_LT is 5.33+ */
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(file);

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#if PERL_VERSION_LE(5, 21, 5)
    XS_VERSION_BOOTCHECK;
#  ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#  endif
#endif

        newXS_deffile("Math::Float128::NOK_POK_val", XS_Math__Float128_NOK_POK_val);
        newXS_deffile("Math::Float128::_win32_infnanstring", XS_Math__Float128__win32_infnanstring);
        newXS_deffile("Math::Float128::flt128_set_prec", XS_Math__Float128_flt128_set_prec);
        newXS_deffile("Math::Float128::flt128_get_prec", XS_Math__Float128_flt128_get_prec);
        newXS_deffile("Math::Float128::InfF128", XS_Math__Float128_InfF128);
        newXS_deffile("Math::Float128::NaNF128", XS_Math__Float128_NaNF128);
        newXS_deffile("Math::Float128::ZeroF128", XS_Math__Float128_ZeroF128);
        newXS_deffile("Math::Float128::UnityF128", XS_Math__Float128_UnityF128);
        newXS_deffile("Math::Float128::is_NaNF128", XS_Math__Float128_is_NaNF128);
        newXS_deffile("Math::Float128::is_InfF128", XS_Math__Float128_is_InfF128);
        newXS_deffile("Math::Float128::is_ZeroF128", XS_Math__Float128_is_ZeroF128);
        newXS_deffile("Math::Float128::_nnum_inc", XS_Math__Float128__nnum_inc);
        newXS_deffile("Math::Float128::STRtoF128", XS_Math__Float128_STRtoF128);
        newXS_deffile("Math::Float128::fromSTR", XS_Math__Float128_fromSTR);
        newXS_deffile("Math::Float128::NVtoF128", XS_Math__Float128_NVtoF128);
        newXS_deffile("Math::Float128::fromNV", XS_Math__Float128_fromNV);
        newXS_deffile("Math::Float128::IVtoF128", XS_Math__Float128_IVtoF128);
        newXS_deffile("Math::Float128::fromIV", XS_Math__Float128_fromIV);
        newXS_deffile("Math::Float128::UVtoF128", XS_Math__Float128_UVtoF128);
        newXS_deffile("Math::Float128::fromUV", XS_Math__Float128_fromUV);
        newXS_deffile("Math::Float128::F128toSTR", XS_Math__Float128_F128toSTR);
        newXS_deffile("Math::Float128::F128toSTRP", XS_Math__Float128_F128toSTRP);
        newXS_deffile("Math::Float128::DESTROY", XS_Math__Float128_DESTROY);
        newXS_deffile("Math::Float128::_LDBL_DIG", XS_Math__Float128__LDBL_DIG);
        newXS_deffile("Math::Float128::_DBL_DIG", XS_Math__Float128__DBL_DIG);
        newXS_deffile("Math::Float128::_FLT128_DIG", XS_Math__Float128__FLT128_DIG);
        newXS_deffile("Math::Float128::_overload_add", XS_Math__Float128__overload_add);
        newXS_deffile("Math::Float128::_overload_mul", XS_Math__Float128__overload_mul);
        newXS_deffile("Math::Float128::_overload_sub", XS_Math__Float128__overload_sub);
        newXS_deffile("Math::Float128::_overload_div", XS_Math__Float128__overload_div);
        newXS_deffile("Math::Float128::_overload_equiv", XS_Math__Float128__overload_equiv);
        newXS_deffile("Math::Float128::_overload_not_equiv", XS_Math__Float128__overload_not_equiv);
        newXS_deffile("Math::Float128::_overload_true", XS_Math__Float128__overload_true);
        newXS_deffile("Math::Float128::_overload_not", XS_Math__Float128__overload_not);
        newXS_deffile("Math::Float128::_overload_add_eq", XS_Math__Float128__overload_add_eq);
        newXS_deffile("Math::Float128::_overload_mul_eq", XS_Math__Float128__overload_mul_eq);
        newXS_deffile("Math::Float128::_overload_sub_eq", XS_Math__Float128__overload_sub_eq);
        newXS_deffile("Math::Float128::_overload_div_eq", XS_Math__Float128__overload_div_eq);
        newXS_deffile("Math::Float128::_overload_lt", XS_Math__Float128__overload_lt);
        newXS_deffile("Math::Float128::_overload_gt", XS_Math__Float128__overload_gt);
        newXS_deffile("Math::Float128::_overload_lte", XS_Math__Float128__overload_lte);
        newXS_deffile("Math::Float128::_overload_gte", XS_Math__Float128__overload_gte);
        newXS_deffile("Math::Float128::_overload_spaceship", XS_Math__Float128__overload_spaceship);
        newXS_deffile("Math::Float128::_overload_copy", XS_Math__Float128__overload_copy);
        newXS_deffile("Math::Float128::F128toF128", XS_Math__Float128_F128toF128);
        newXS_deffile("Math::Float128::fromF128", XS_Math__Float128_fromF128);
        newXS_deffile("Math::Float128::_itsa", XS_Math__Float128__itsa);
        newXS_deffile("Math::Float128::_overload_abs", XS_Math__Float128__overload_abs);
        newXS_deffile("Math::Float128::_overload_int", XS_Math__Float128__overload_int);
        newXS_deffile("Math::Float128::_overload_sqrt", XS_Math__Float128__overload_sqrt);
        newXS_deffile("Math::Float128::_overload_log", XS_Math__Float128__overload_log);
        newXS_deffile("Math::Float128::_overload_exp", XS_Math__Float128__overload_exp);
        newXS_deffile("Math::Float128::_overload_sin", XS_Math__Float128__overload_sin);
        newXS_deffile("Math::Float128::_overload_cos", XS_Math__Float128__overload_cos);
        newXS_deffile("Math::Float128::_overload_atan2", XS_Math__Float128__overload_atan2);
        newXS_deffile("Math::Float128::_overload_inc", XS_Math__Float128__overload_inc);
        newXS_deffile("Math::Float128::_overload_dec", XS_Math__Float128__overload_dec);
        newXS_deffile("Math::Float128::_overload_pow", XS_Math__Float128__overload_pow);
        newXS_deffile("Math::Float128::_overload_pow_eq", XS_Math__Float128__overload_pow_eq);
        newXS_deffile("Math::Float128::cmp2NV", XS_Math__Float128_cmp2NV);
        newXS_deffile("Math::Float128::F128toNV", XS_Math__Float128_F128toNV);
        newXS_deffile("Math::Float128::_FLT128_MAX", XS_Math__Float128__FLT128_MAX);
        newXS_deffile("Math::Float128::_FLT128_MIN", XS_Math__Float128__FLT128_MIN);
        newXS_deffile("Math::Float128::_FLT128_EPSILON", XS_Math__Float128__FLT128_EPSILON);
        newXS_deffile("Math::Float128::_FLT128_DENORM_MIN", XS_Math__Float128__FLT128_DENORM_MIN);
        newXS_deffile("Math::Float128::_FLT128_MANT_DIG", XS_Math__Float128__FLT128_MANT_DIG);
        newXS_deffile("Math::Float128::_FLT128_MIN_EXP", XS_Math__Float128__FLT128_MIN_EXP);
        newXS_deffile("Math::Float128::_FLT128_MAX_EXP", XS_Math__Float128__FLT128_MAX_EXP);
        newXS_deffile("Math::Float128::_FLT128_MIN_10_EXP", XS_Math__Float128__FLT128_MIN_10_EXP);
        newXS_deffile("Math::Float128::_FLT128_MAX_10_EXP", XS_Math__Float128__FLT128_MAX_10_EXP);
        newXS_deffile("Math::Float128::_M_Eq", XS_Math__Float128__M_Eq);
        newXS_deffile("Math::Float128::_M_LOG2Eq", XS_Math__Float128__M_LOG2Eq);
        newXS_deffile("Math::Float128::_M_LOG10Eq", XS_Math__Float128__M_LOG10Eq);
        newXS_deffile("Math::Float128::_M_LN2q", XS_Math__Float128__M_LN2q);
        newXS_deffile("Math::Float128::_M_LN10q", XS_Math__Float128__M_LN10q);
        newXS_deffile("Math::Float128::_M_PIq", XS_Math__Float128__M_PIq);
        newXS_deffile("Math::Float128::_M_PI_2q", XS_Math__Float128__M_PI_2q);
        newXS_deffile("Math::Float128::_M_PI_4q", XS_Math__Float128__M_PI_4q);
        newXS_deffile("Math::Float128::_M_1_PIq", XS_Math__Float128__M_1_PIq);
        newXS_deffile("Math::Float128::_M_2_PIq", XS_Math__Float128__M_2_PIq);
        newXS_deffile("Math::Float128::_M_2_SQRTPIq", XS_Math__Float128__M_2_SQRTPIq);
        newXS_deffile("Math::Float128::_M_SQRT2q", XS_Math__Float128__M_SQRT2q);
        newXS_deffile("Math::Float128::_M_SQRT1_2q", XS_Math__Float128__M_SQRT1_2q);
        newXS_deffile("Math::Float128::_f128_bytes", XS_Math__Float128__f128_bytes);
        newXS_deffile("Math::Float128::acos_F128", XS_Math__Float128_acos_F128);
        newXS_deffile("Math::Float128::acosh_F128", XS_Math__Float128_acosh_F128);
        newXS_deffile("Math::Float128::asin_F128", XS_Math__Float128_asin_F128);
        newXS_deffile("Math::Float128::asinh_F128", XS_Math__Float128_asinh_F128);
        newXS_deffile("Math::Float128::atan_F128", XS_Math__Float128_atan_F128);
        newXS_deffile("Math::Float128::atanh_F128", XS_Math__Float128_atanh_F128);
        newXS_deffile("Math::Float128::atan2_F128", XS_Math__Float128_atan2_F128);
        newXS_deffile("Math::Float128::cbrt_F128", XS_Math__Float128_cbrt_F128);
        newXS_deffile("Math::Float128::ceil_F128", XS_Math__Float128_ceil_F128);
        newXS_deffile("Math::Float128::copysign_F128", XS_Math__Float128_copysign_F128);
        newXS_deffile("Math::Float128::cosh_F128", XS_Math__Float128_cosh_F128);
        newXS_deffile("Math::Float128::cos_F128", XS_Math__Float128_cos_F128);
        newXS_deffile("Math::Float128::erf_F128", XS_Math__Float128_erf_F128);
        newXS_deffile("Math::Float128::erfc_F128", XS_Math__Float128_erfc_F128);
        newXS_deffile("Math::Float128::exp_F128", XS_Math__Float128_exp_F128);
        newXS_deffile("Math::Float128::expm1_F128", XS_Math__Float128_expm1_F128);
        newXS_deffile("Math::Float128::fabs_F128", XS_Math__Float128_fabs_F128);
        newXS_deffile("Math::Float128::fdim_F128", XS_Math__Float128_fdim_F128);
        newXS_deffile("Math::Float128::finite_F128", XS_Math__Float128_finite_F128);
        newXS_deffile("Math::Float128::floor_F128", XS_Math__Float128_floor_F128);
        newXS_deffile("Math::Float128::fma_F128", XS_Math__Float128_fma_F128);
        newXS_deffile("Math::Float128::fmax_F128", XS_Math__Float128_fmax_F128);
        newXS_deffile("Math::Float128::fmin_F128", XS_Math__Float128_fmin_F128);
        newXS_deffile("Math::Float128::fmod_F128", XS_Math__Float128_fmod_F128);
        newXS_deffile("Math::Float128::hypot_F128", XS_Math__Float128_hypot_F128);
        newXS_deffile("Math::Float128::frexp_F128", XS_Math__Float128_frexp_F128);
        newXS_deffile("Math::Float128::ldexp_F128", XS_Math__Float128_ldexp_F128);
        newXS_deffile("Math::Float128::isinf_F128", XS_Math__Float128_isinf_F128);
        newXS_deffile("Math::Float128::ilogb_F128", XS_Math__Float128_ilogb_F128);
        newXS_deffile("Math::Float128::isnan_F128", XS_Math__Float128_isnan_F128);
        newXS_deffile("Math::Float128::j0_F128", XS_Math__Float128_j0_F128);
        newXS_deffile("Math::Float128::j1_F128", XS_Math__Float128_j1_F128);
        newXS_deffile("Math::Float128::jn_F128", XS_Math__Float128_jn_F128);
        newXS_deffile("Math::Float128::lgamma_F128", XS_Math__Float128_lgamma_F128);
        newXS_deffile("Math::Float128::llrint_F128", XS_Math__Float128_llrint_F128);
        newXS_deffile("Math::Float128::llround_F128", XS_Math__Float128_llround_F128);
        newXS_deffile("Math::Float128::lrint_F128", XS_Math__Float128_lrint_F128);
        newXS_deffile("Math::Float128::lround_F128", XS_Math__Float128_lround_F128);
        newXS_deffile("Math::Float128::log_F128", XS_Math__Float128_log_F128);
        newXS_deffile("Math::Float128::log10_F128", XS_Math__Float128_log10_F128);
        newXS_deffile("Math::Float128::log2_F128", XS_Math__Float128_log2_F128);
        newXS_deffile("Math::Float128::log1p_F128", XS_Math__Float128_log1p_F128);
        newXS_deffile("Math::Float128::modf_F128", XS_Math__Float128_modf_F128);
        newXS_deffile("Math::Float128::nan_F128", XS_Math__Float128_nan_F128);
        newXS_deffile("Math::Float128::nearbyint_F128", XS_Math__Float128_nearbyint_F128);
        newXS_deffile("Math::Float128::nextafter_F128", XS_Math__Float128_nextafter_F128);
        newXS_deffile("Math::Float128::pow_F128", XS_Math__Float128_pow_F128);
        newXS_deffile("Math::Float128::remainder_F128", XS_Math__Float128_remainder_F128);
        newXS_deffile("Math::Float128::remquo_F128", XS_Math__Float128_remquo_F128);
        newXS_deffile("Math::Float128::rint_F128", XS_Math__Float128_rint_F128);
        newXS_deffile("Math::Float128::round_F128", XS_Math__Float128_round_F128);
        newXS_deffile("Math::Float128::scalbln_F128", XS_Math__Float128_scalbln_F128);
        newXS_deffile("Math::Float128::scalbn_F128", XS_Math__Float128_scalbn_F128);
        newXS_deffile("Math::Float128::signbit_F128", XS_Math__Float128_signbit_F128);
        newXS_deffile("Math::Float128::sincos_F128", XS_Math__Float128_sincos_F128);
        newXS_deffile("Math::Float128::sinh_F128", XS_Math__Float128_sinh_F128);
        newXS_deffile("Math::Float128::sin_F128", XS_Math__Float128_sin_F128);
        newXS_deffile("Math::Float128::sqrt_F128", XS_Math__Float128_sqrt_F128);
        newXS_deffile("Math::Float128::tan_F128", XS_Math__Float128_tan_F128);
        newXS_deffile("Math::Float128::tanh_F128", XS_Math__Float128_tanh_F128);
        newXS_deffile("Math::Float128::tgamma_F128", XS_Math__Float128_tgamma_F128);
        newXS_deffile("Math::Float128::trunc_F128", XS_Math__Float128_trunc_F128);
        newXS_deffile("Math::Float128::y0_F128", XS_Math__Float128_y0_F128);
        newXS_deffile("Math::Float128::y1_F128", XS_Math__Float128_y1_F128);
        newXS_deffile("Math::Float128::yn_F128", XS_Math__Float128_yn_F128);
        newXS_deffile("Math::Float128::_longlong2iv_is_ok", XS_Math__Float128__longlong2iv_is_ok);
        newXS_deffile("Math::Float128::_long2iv_is_ok", XS_Math__Float128__long2iv_is_ok);
        newXS_deffile("Math::Float128::_flt_radix", XS_Math__Float128__flt_radix);
        newXS_deffile("Math::Float128::_fegetround", XS_Math__Float128__fegetround);
        newXS_deffile("Math::Float128::nnumflag", XS_Math__Float128_nnumflag);
        newXS_deffile("Math::Float128::clear_nnum", XS_Math__Float128_clear_nnum);
        newXS_deffile("Math::Float128::set_nnum", XS_Math__Float128_set_nnum);
        newXS_deffile("Math::Float128::_lln", XS_Math__Float128__lln);
        newXS_deffile("Math::Float128::nok_pokflag", XS_Math__Float128_nok_pokflag);
        newXS_deffile("Math::Float128::clear_nok_pok", XS_Math__Float128_clear_nok_pok);
        newXS_deffile("Math::Float128::set_nok_pok", XS_Math__Float128_set_nok_pok);
        newXS_deffile("Math::Float128::_SvNOK", XS_Math__Float128__SvNOK);
        newXS_deffile("Math::Float128::_SvPOK", XS_Math__Float128__SvPOK);
        newXS_deffile("Math::Float128::_avoid_inf_cast", XS_Math__Float128__avoid_inf_cast);
#if PERL_VERSION_LE(5, 21, 5)
#  if PERL_VERSION_GE(5, 9, 0)
    if (PL_unitcheckav)
        call_list(PL_scopestack_ix, PL_unitcheckav);
#  endif
    XSRETURN_YES;
#else
    Perl_xs_boot_epilog(aTHX_ ax);
#endif
}

